<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountSkuIdentifier ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountSkuIdentifier
 * @subpackage Arrays
 */
class ArrayOfAccountSkuIdentifier extends AbstractStructArrayBase
{
    /**
     * The AccountSkuIdentifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountSkuIdentifier[]
     */
    public $AccountSkuIdentifier;
    /**
     * Constructor method for ArrayOfAccountSkuIdentifier
     * @uses ArrayOfAccountSkuIdentifier::setAccountSkuIdentifier()
     * @param \StructType\AccountSkuIdentifier[] $accountSkuIdentifier
     */
    public function __construct(array $accountSkuIdentifier = array())
    {
        $this
            ->setAccountSkuIdentifier($accountSkuIdentifier);
    }
    /**
     * Get AccountSkuIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountSkuIdentifier[]|null
     */
    public function getAccountSkuIdentifier()
    {
        return isset($this->AccountSkuIdentifier) ? $this->AccountSkuIdentifier : null;
    }
    /**
     * Set AccountSkuIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountSkuIdentifier[] $accountSkuIdentifier
     * @return \ArrayType\ArrayOfAccountSkuIdentifier
     */
    public function setAccountSkuIdentifier(array $accountSkuIdentifier = array())
    {
        foreach ($accountSkuIdentifier as $arrayOfAccountSkuIdentifierAccountSkuIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountSkuIdentifierAccountSkuIdentifierItem instanceof \StructType\AccountSkuIdentifier) {
                throw new \InvalidArgumentException(sprintf('The AccountSkuIdentifier property can only contain items of \StructType\AccountSkuIdentifier, "%s" given', is_object($arrayOfAccountSkuIdentifierAccountSkuIdentifierItem) ? get_class($arrayOfAccountSkuIdentifierAccountSkuIdentifierItem) : gettype($arrayOfAccountSkuIdentifierAccountSkuIdentifierItem)), __LINE__);
            }
        }
        if (is_null($accountSkuIdentifier) || (is_array($accountSkuIdentifier) && empty($accountSkuIdentifier))) {
            unset($this->AccountSkuIdentifier);
        } else {
            $this->AccountSkuIdentifier = $accountSkuIdentifier;
        }
        return $this;
    }
    /**
     * Add item to AccountSkuIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountSkuIdentifier $item
     * @return \ArrayType\ArrayOfAccountSkuIdentifier
     */
    public function addToAccountSkuIdentifier(\StructType\AccountSkuIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountSkuIdentifier) {
            throw new \InvalidArgumentException(sprintf('The AccountSkuIdentifier property can only contain items of \StructType\AccountSkuIdentifier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AccountSkuIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountSkuIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountSkuIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountSkuIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountSkuIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountSkuIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountSkuIdentifier
     */
    public function getAttributeName()
    {
        return 'AccountSkuIdentifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAccountSkuIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
