<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdministrativeUnitMember ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdministrativeUnitMember
 * @subpackage Arrays
 */
class ArrayOfAdministrativeUnitMember extends AbstractStructArrayBase
{
    /**
     * The AdministrativeUnitMember
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdministrativeUnitMember[]
     */
    public $AdministrativeUnitMember;
    /**
     * Constructor method for ArrayOfAdministrativeUnitMember
     * @uses ArrayOfAdministrativeUnitMember::setAdministrativeUnitMember()
     * @param \StructType\AdministrativeUnitMember[] $administrativeUnitMember
     */
    public function __construct(array $administrativeUnitMember = array())
    {
        $this
            ->setAdministrativeUnitMember($administrativeUnitMember);
    }
    /**
     * Get AdministrativeUnitMember value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdministrativeUnitMember[]|null
     */
    public function getAdministrativeUnitMember()
    {
        return isset($this->AdministrativeUnitMember) ? $this->AdministrativeUnitMember : null;
    }
    /**
     * Set AdministrativeUnitMember value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdministrativeUnitMember[] $administrativeUnitMember
     * @return \ArrayType\ArrayOfAdministrativeUnitMember
     */
    public function setAdministrativeUnitMember(array $administrativeUnitMember = array())
    {
        foreach ($administrativeUnitMember as $arrayOfAdministrativeUnitMemberAdministrativeUnitMemberItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdministrativeUnitMemberAdministrativeUnitMemberItem instanceof \StructType\AdministrativeUnitMember) {
                throw new \InvalidArgumentException(sprintf('The AdministrativeUnitMember property can only contain items of \StructType\AdministrativeUnitMember, "%s" given', is_object($arrayOfAdministrativeUnitMemberAdministrativeUnitMemberItem) ? get_class($arrayOfAdministrativeUnitMemberAdministrativeUnitMemberItem) : gettype($arrayOfAdministrativeUnitMemberAdministrativeUnitMemberItem)), __LINE__);
            }
        }
        if (is_null($administrativeUnitMember) || (is_array($administrativeUnitMember) && empty($administrativeUnitMember))) {
            unset($this->AdministrativeUnitMember);
        } else {
            $this->AdministrativeUnitMember = $administrativeUnitMember;
        }
        return $this;
    }
    /**
     * Add item to AdministrativeUnitMember value
     * @throws \InvalidArgumentException
     * @param \StructType\AdministrativeUnitMember $item
     * @return \ArrayType\ArrayOfAdministrativeUnitMember
     */
    public function addToAdministrativeUnitMember(\StructType\AdministrativeUnitMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdministrativeUnitMember) {
            throw new \InvalidArgumentException(sprintf('The AdministrativeUnitMember property can only contain items of \StructType\AdministrativeUnitMember, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AdministrativeUnitMember[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdministrativeUnitMember|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdministrativeUnitMember|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdministrativeUnitMember|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdministrativeUnitMember|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdministrativeUnitMember|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdministrativeUnitMember
     */
    public function getAttributeName()
    {
        return 'AdministrativeUnitMember';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdministrativeUnitMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
