<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDirSyncFeatureDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDirSyncFeatureDetails
 * @subpackage Arrays
 */
class ArrayOfDirSyncFeatureDetails extends AbstractStructArrayBase
{
    /**
     * The DirSyncFeatureDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DirSyncFeatureDetails[]
     */
    public $DirSyncFeatureDetails;
    /**
     * Constructor method for ArrayOfDirSyncFeatureDetails
     * @uses ArrayOfDirSyncFeatureDetails::setDirSyncFeatureDetails()
     * @param \StructType\DirSyncFeatureDetails[] $dirSyncFeatureDetails
     */
    public function __construct(array $dirSyncFeatureDetails = array())
    {
        $this
            ->setDirSyncFeatureDetails($dirSyncFeatureDetails);
    }
    /**
     * Get DirSyncFeatureDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DirSyncFeatureDetails[]|null
     */
    public function getDirSyncFeatureDetails()
    {
        return isset($this->DirSyncFeatureDetails) ? $this->DirSyncFeatureDetails : null;
    }
    /**
     * Set DirSyncFeatureDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DirSyncFeatureDetails[] $dirSyncFeatureDetails
     * @return \ArrayType\ArrayOfDirSyncFeatureDetails
     */
    public function setDirSyncFeatureDetails(array $dirSyncFeatureDetails = array())
    {
        foreach ($dirSyncFeatureDetails as $arrayOfDirSyncFeatureDetailsDirSyncFeatureDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfDirSyncFeatureDetailsDirSyncFeatureDetailsItem instanceof \StructType\DirSyncFeatureDetails) {
                throw new \InvalidArgumentException(sprintf('The DirSyncFeatureDetails property can only contain items of \StructType\DirSyncFeatureDetails, "%s" given', is_object($arrayOfDirSyncFeatureDetailsDirSyncFeatureDetailsItem) ? get_class($arrayOfDirSyncFeatureDetailsDirSyncFeatureDetailsItem) : gettype($arrayOfDirSyncFeatureDetailsDirSyncFeatureDetailsItem)), __LINE__);
            }
        }
        if (is_null($dirSyncFeatureDetails) || (is_array($dirSyncFeatureDetails) && empty($dirSyncFeatureDetails))) {
            unset($this->DirSyncFeatureDetails);
        } else {
            $this->DirSyncFeatureDetails = $dirSyncFeatureDetails;
        }
        return $this;
    }
    /**
     * Add item to DirSyncFeatureDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\DirSyncFeatureDetails $item
     * @return \ArrayType\ArrayOfDirSyncFeatureDetails
     */
    public function addToDirSyncFeatureDetails(\StructType\DirSyncFeatureDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DirSyncFeatureDetails) {
            throw new \InvalidArgumentException(sprintf('The DirSyncFeatureDetails property can only contain items of \StructType\DirSyncFeatureDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DirSyncFeatureDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DirSyncFeatureDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DirSyncFeatureDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DirSyncFeatureDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DirSyncFeatureDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DirSyncFeatureDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DirSyncFeatureDetails
     */
    public function getAttributeName()
    {
        return 'DirSyncFeatureDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDirSyncFeatureDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
