<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDirSyncProvisioningError ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDirSyncProvisioningError
 * @subpackage Arrays
 */
class ArrayOfDirSyncProvisioningError extends AbstractStructArrayBase
{
    /**
     * The DirSyncProvisioningError
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DirSyncProvisioningError[]
     */
    public $DirSyncProvisioningError;
    /**
     * Constructor method for ArrayOfDirSyncProvisioningError
     * @uses ArrayOfDirSyncProvisioningError::setDirSyncProvisioningError()
     * @param \StructType\DirSyncProvisioningError[] $dirSyncProvisioningError
     */
    public function __construct(array $dirSyncProvisioningError = array())
    {
        $this
            ->setDirSyncProvisioningError($dirSyncProvisioningError);
    }
    /**
     * Get DirSyncProvisioningError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DirSyncProvisioningError[]|null
     */
    public function getDirSyncProvisioningError()
    {
        return isset($this->DirSyncProvisioningError) ? $this->DirSyncProvisioningError : null;
    }
    /**
     * Set DirSyncProvisioningError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DirSyncProvisioningError[] $dirSyncProvisioningError
     * @return \ArrayType\ArrayOfDirSyncProvisioningError
     */
    public function setDirSyncProvisioningError(array $dirSyncProvisioningError = array())
    {
        foreach ($dirSyncProvisioningError as $arrayOfDirSyncProvisioningErrorDirSyncProvisioningErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfDirSyncProvisioningErrorDirSyncProvisioningErrorItem instanceof \StructType\DirSyncProvisioningError) {
                throw new \InvalidArgumentException(sprintf('The DirSyncProvisioningError property can only contain items of \StructType\DirSyncProvisioningError, "%s" given', is_object($arrayOfDirSyncProvisioningErrorDirSyncProvisioningErrorItem) ? get_class($arrayOfDirSyncProvisioningErrorDirSyncProvisioningErrorItem) : gettype($arrayOfDirSyncProvisioningErrorDirSyncProvisioningErrorItem)), __LINE__);
            }
        }
        if (is_null($dirSyncProvisioningError) || (is_array($dirSyncProvisioningError) && empty($dirSyncProvisioningError))) {
            unset($this->DirSyncProvisioningError);
        } else {
            $this->DirSyncProvisioningError = $dirSyncProvisioningError;
        }
        return $this;
    }
    /**
     * Add item to DirSyncProvisioningError value
     * @throws \InvalidArgumentException
     * @param \StructType\DirSyncProvisioningError $item
     * @return \ArrayType\ArrayOfDirSyncProvisioningError
     */
    public function addToDirSyncProvisioningError(\StructType\DirSyncProvisioningError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DirSyncProvisioningError) {
            throw new \InvalidArgumentException(sprintf('The DirSyncProvisioningError property can only contain items of \StructType\DirSyncProvisioningError, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DirSyncProvisioningError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DirSyncProvisioningError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DirSyncProvisioningError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DirSyncProvisioningError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DirSyncProvisioningError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DirSyncProvisioningError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DirSyncProvisioningError
     */
    public function getAttributeName()
    {
        return 'DirSyncProvisioningError';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDirSyncProvisioningError
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
