<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLicenseAssignment ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLicenseAssignment
 * @subpackage Arrays
 */
class ArrayOfLicenseAssignment extends AbstractStructArrayBase
{
    /**
     * The LicenseAssignment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LicenseAssignment[]
     */
    public $LicenseAssignment;
    /**
     * Constructor method for ArrayOfLicenseAssignment
     * @uses ArrayOfLicenseAssignment::setLicenseAssignment()
     * @param \StructType\LicenseAssignment[] $licenseAssignment
     */
    public function __construct(array $licenseAssignment = array())
    {
        $this
            ->setLicenseAssignment($licenseAssignment);
    }
    /**
     * Get LicenseAssignment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LicenseAssignment[]|null
     */
    public function getLicenseAssignment()
    {
        return isset($this->LicenseAssignment) ? $this->LicenseAssignment : null;
    }
    /**
     * Set LicenseAssignment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LicenseAssignment[] $licenseAssignment
     * @return \ArrayType\ArrayOfLicenseAssignment
     */
    public function setLicenseAssignment(array $licenseAssignment = array())
    {
        foreach ($licenseAssignment as $arrayOfLicenseAssignmentLicenseAssignmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfLicenseAssignmentLicenseAssignmentItem instanceof \StructType\LicenseAssignment) {
                throw new \InvalidArgumentException(sprintf('The LicenseAssignment property can only contain items of \StructType\LicenseAssignment, "%s" given', is_object($arrayOfLicenseAssignmentLicenseAssignmentItem) ? get_class($arrayOfLicenseAssignmentLicenseAssignmentItem) : gettype($arrayOfLicenseAssignmentLicenseAssignmentItem)), __LINE__);
            }
        }
        if (is_null($licenseAssignment) || (is_array($licenseAssignment) && empty($licenseAssignment))) {
            unset($this->LicenseAssignment);
        } else {
            $this->LicenseAssignment = $licenseAssignment;
        }
        return $this;
    }
    /**
     * Add item to LicenseAssignment value
     * @throws \InvalidArgumentException
     * @param \StructType\LicenseAssignment $item
     * @return \ArrayType\ArrayOfLicenseAssignment
     */
    public function addToLicenseAssignment(\StructType\LicenseAssignment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LicenseAssignment) {
            throw new \InvalidArgumentException(sprintf('The LicenseAssignment property can only contain items of \StructType\LicenseAssignment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LicenseAssignment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LicenseAssignment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LicenseAssignment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LicenseAssignment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LicenseAssignment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LicenseAssignment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LicenseAssignment
     */
    public function getAttributeName()
    {
        return 'LicenseAssignment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLicenseAssignment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
