<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLicenseErrorDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLicenseErrorDetail
 * @subpackage Arrays
 */
class ArrayOfLicenseErrorDetail extends AbstractStructArrayBase
{
    /**
     * The LicenseErrorDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LicenseErrorDetail[]
     */
    public $LicenseErrorDetail;
    /**
     * Constructor method for ArrayOfLicenseErrorDetail
     * @uses ArrayOfLicenseErrorDetail::setLicenseErrorDetail()
     * @param \StructType\LicenseErrorDetail[] $licenseErrorDetail
     */
    public function __construct(array $licenseErrorDetail = array())
    {
        $this
            ->setLicenseErrorDetail($licenseErrorDetail);
    }
    /**
     * Get LicenseErrorDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LicenseErrorDetail[]|null
     */
    public function getLicenseErrorDetail()
    {
        return isset($this->LicenseErrorDetail) ? $this->LicenseErrorDetail : null;
    }
    /**
     * Set LicenseErrorDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LicenseErrorDetail[] $licenseErrorDetail
     * @return \ArrayType\ArrayOfLicenseErrorDetail
     */
    public function setLicenseErrorDetail(array $licenseErrorDetail = array())
    {
        foreach ($licenseErrorDetail as $arrayOfLicenseErrorDetailLicenseErrorDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfLicenseErrorDetailLicenseErrorDetailItem instanceof \StructType\LicenseErrorDetail) {
                throw new \InvalidArgumentException(sprintf('The LicenseErrorDetail property can only contain items of \StructType\LicenseErrorDetail, "%s" given', is_object($arrayOfLicenseErrorDetailLicenseErrorDetailItem) ? get_class($arrayOfLicenseErrorDetailLicenseErrorDetailItem) : gettype($arrayOfLicenseErrorDetailLicenseErrorDetailItem)), __LINE__);
            }
        }
        if (is_null($licenseErrorDetail) || (is_array($licenseErrorDetail) && empty($licenseErrorDetail))) {
            unset($this->LicenseErrorDetail);
        } else {
            $this->LicenseErrorDetail = $licenseErrorDetail;
        }
        return $this;
    }
    /**
     * Add item to LicenseErrorDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\LicenseErrorDetail $item
     * @return \ArrayType\ArrayOfLicenseErrorDetail
     */
    public function addToLicenseErrorDetail(\StructType\LicenseErrorDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LicenseErrorDetail) {
            throw new \InvalidArgumentException(sprintf('The LicenseErrorDetail property can only contain items of \StructType\LicenseErrorDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LicenseErrorDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LicenseErrorDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LicenseErrorDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LicenseErrorDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LicenseErrorDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LicenseErrorDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LicenseErrorDetail
     */
    public function getAttributeName()
    {
        return 'LicenseErrorDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLicenseErrorDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
