<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfObjectWithDirSyncErrors ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfObjectWithDirSyncErrors
 * @subpackage Arrays
 */
class ArrayOfObjectWithDirSyncErrors extends AbstractStructArrayBase
{
    /**
     * The ObjectWithDirSyncErrors
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ObjectWithDirSyncErrors[]
     */
    public $ObjectWithDirSyncErrors;
    /**
     * Constructor method for ArrayOfObjectWithDirSyncErrors
     * @uses ArrayOfObjectWithDirSyncErrors::setObjectWithDirSyncErrors()
     * @param \StructType\ObjectWithDirSyncErrors[] $objectWithDirSyncErrors
     */
    public function __construct(array $objectWithDirSyncErrors = array())
    {
        $this
            ->setObjectWithDirSyncErrors($objectWithDirSyncErrors);
    }
    /**
     * Get ObjectWithDirSyncErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ObjectWithDirSyncErrors[]|null
     */
    public function getObjectWithDirSyncErrors()
    {
        return isset($this->ObjectWithDirSyncErrors) ? $this->ObjectWithDirSyncErrors : null;
    }
    /**
     * Set ObjectWithDirSyncErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ObjectWithDirSyncErrors[] $objectWithDirSyncErrors
     * @return \ArrayType\ArrayOfObjectWithDirSyncErrors
     */
    public function setObjectWithDirSyncErrors(array $objectWithDirSyncErrors = array())
    {
        foreach ($objectWithDirSyncErrors as $arrayOfObjectWithDirSyncErrorsObjectWithDirSyncErrorsItem) {
            // validation for constraint: itemType
            if (!$arrayOfObjectWithDirSyncErrorsObjectWithDirSyncErrorsItem instanceof \StructType\ObjectWithDirSyncErrors) {
                throw new \InvalidArgumentException(sprintf('The ObjectWithDirSyncErrors property can only contain items of \StructType\ObjectWithDirSyncErrors, "%s" given', is_object($arrayOfObjectWithDirSyncErrorsObjectWithDirSyncErrorsItem) ? get_class($arrayOfObjectWithDirSyncErrorsObjectWithDirSyncErrorsItem) : gettype($arrayOfObjectWithDirSyncErrorsObjectWithDirSyncErrorsItem)), __LINE__);
            }
        }
        if (is_null($objectWithDirSyncErrors) || (is_array($objectWithDirSyncErrors) && empty($objectWithDirSyncErrors))) {
            unset($this->ObjectWithDirSyncErrors);
        } else {
            $this->ObjectWithDirSyncErrors = $objectWithDirSyncErrors;
        }
        return $this;
    }
    /**
     * Add item to ObjectWithDirSyncErrors value
     * @throws \InvalidArgumentException
     * @param \StructType\ObjectWithDirSyncErrors $item
     * @return \ArrayType\ArrayOfObjectWithDirSyncErrors
     */
    public function addToObjectWithDirSyncErrors(\StructType\ObjectWithDirSyncErrors $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ObjectWithDirSyncErrors) {
            throw new \InvalidArgumentException(sprintf('The ObjectWithDirSyncErrors property can only contain items of \StructType\ObjectWithDirSyncErrors, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ObjectWithDirSyncErrors[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ObjectWithDirSyncErrors|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ObjectWithDirSyncErrors|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ObjectWithDirSyncErrors|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ObjectWithDirSyncErrors|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ObjectWithDirSyncErrors|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ObjectWithDirSyncErrors
     */
    public function getAttributeName()
    {
        return 'ObjectWithDirSyncErrors';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfObjectWithDirSyncErrors
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
