<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPartnerRoleMapEntry ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPartnerRoleMapEntry
 * @subpackage Arrays
 */
class ArrayOfPartnerRoleMapEntry extends AbstractStructArrayBase
{
    /**
     * The PartnerRoleMapEntry
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PartnerRoleMapEntry[]
     */
    public $PartnerRoleMapEntry;
    /**
     * Constructor method for ArrayOfPartnerRoleMapEntry
     * @uses ArrayOfPartnerRoleMapEntry::setPartnerRoleMapEntry()
     * @param \StructType\PartnerRoleMapEntry[] $partnerRoleMapEntry
     */
    public function __construct(array $partnerRoleMapEntry = array())
    {
        $this
            ->setPartnerRoleMapEntry($partnerRoleMapEntry);
    }
    /**
     * Get PartnerRoleMapEntry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PartnerRoleMapEntry[]|null
     */
    public function getPartnerRoleMapEntry()
    {
        return isset($this->PartnerRoleMapEntry) ? $this->PartnerRoleMapEntry : null;
    }
    /**
     * Set PartnerRoleMapEntry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PartnerRoleMapEntry[] $partnerRoleMapEntry
     * @return \ArrayType\ArrayOfPartnerRoleMapEntry
     */
    public function setPartnerRoleMapEntry(array $partnerRoleMapEntry = array())
    {
        foreach ($partnerRoleMapEntry as $arrayOfPartnerRoleMapEntryPartnerRoleMapEntryItem) {
            // validation for constraint: itemType
            if (!$arrayOfPartnerRoleMapEntryPartnerRoleMapEntryItem instanceof \StructType\PartnerRoleMapEntry) {
                throw new \InvalidArgumentException(sprintf('The PartnerRoleMapEntry property can only contain items of \StructType\PartnerRoleMapEntry, "%s" given', is_object($arrayOfPartnerRoleMapEntryPartnerRoleMapEntryItem) ? get_class($arrayOfPartnerRoleMapEntryPartnerRoleMapEntryItem) : gettype($arrayOfPartnerRoleMapEntryPartnerRoleMapEntryItem)), __LINE__);
            }
        }
        if (is_null($partnerRoleMapEntry) || (is_array($partnerRoleMapEntry) && empty($partnerRoleMapEntry))) {
            unset($this->PartnerRoleMapEntry);
        } else {
            $this->PartnerRoleMapEntry = $partnerRoleMapEntry;
        }
        return $this;
    }
    /**
     * Add item to PartnerRoleMapEntry value
     * @throws \InvalidArgumentException
     * @param \StructType\PartnerRoleMapEntry $item
     * @return \ArrayType\ArrayOfPartnerRoleMapEntry
     */
    public function addToPartnerRoleMapEntry(\StructType\PartnerRoleMapEntry $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PartnerRoleMapEntry) {
            throw new \InvalidArgumentException(sprintf('The PartnerRoleMapEntry property can only contain items of \StructType\PartnerRoleMapEntry, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PartnerRoleMapEntry[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PartnerRoleMapEntry|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PartnerRoleMapEntry|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PartnerRoleMapEntry|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PartnerRoleMapEntry|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PartnerRoleMapEntry|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PartnerRoleMapEntry
     */
    public function getAttributeName()
    {
        return 'PartnerRoleMapEntry';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPartnerRoleMapEntry
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
