<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRestoreUserError ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRestoreUserError
 * @subpackage Arrays
 */
class ArrayOfRestoreUserError extends AbstractStructArrayBase
{
    /**
     * The RestoreUserError
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RestoreUserError[]
     */
    public $RestoreUserError;
    /**
     * Constructor method for ArrayOfRestoreUserError
     * @uses ArrayOfRestoreUserError::setRestoreUserError()
     * @param \StructType\RestoreUserError[] $restoreUserError
     */
    public function __construct(array $restoreUserError = array())
    {
        $this
            ->setRestoreUserError($restoreUserError);
    }
    /**
     * Get RestoreUserError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RestoreUserError[]|null
     */
    public function getRestoreUserError()
    {
        return isset($this->RestoreUserError) ? $this->RestoreUserError : null;
    }
    /**
     * Set RestoreUserError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RestoreUserError[] $restoreUserError
     * @return \ArrayType\ArrayOfRestoreUserError
     */
    public function setRestoreUserError(array $restoreUserError = array())
    {
        foreach ($restoreUserError as $arrayOfRestoreUserErrorRestoreUserErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfRestoreUserErrorRestoreUserErrorItem instanceof \StructType\RestoreUserError) {
                throw new \InvalidArgumentException(sprintf('The RestoreUserError property can only contain items of \StructType\RestoreUserError, "%s" given', is_object($arrayOfRestoreUserErrorRestoreUserErrorItem) ? get_class($arrayOfRestoreUserErrorRestoreUserErrorItem) : gettype($arrayOfRestoreUserErrorRestoreUserErrorItem)), __LINE__);
            }
        }
        if (is_null($restoreUserError) || (is_array($restoreUserError) && empty($restoreUserError))) {
            unset($this->RestoreUserError);
        } else {
            $this->RestoreUserError = $restoreUserError;
        }
        return $this;
    }
    /**
     * Add item to RestoreUserError value
     * @throws \InvalidArgumentException
     * @param \StructType\RestoreUserError $item
     * @return \ArrayType\ArrayOfRestoreUserError
     */
    public function addToRestoreUserError(\StructType\RestoreUserError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RestoreUserError) {
            throw new \InvalidArgumentException(sprintf('The RestoreUserError property can only contain items of \StructType\RestoreUserError, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RestoreUserError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RestoreUserError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RestoreUserError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RestoreUserError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RestoreUserError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RestoreUserError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RestoreUserError
     */
    public function getAttributeName()
    {
        return 'RestoreUserError';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRestoreUserError
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
