<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServicePrincipalCredential ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfServicePrincipalCredential
 * @subpackage Arrays
 */
class ArrayOfServicePrincipalCredential extends AbstractStructArrayBase
{
    /**
     * The ServicePrincipalCredential
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServicePrincipalCredential[]
     */
    public $ServicePrincipalCredential;
    /**
     * Constructor method for ArrayOfServicePrincipalCredential
     * @uses ArrayOfServicePrincipalCredential::setServicePrincipalCredential()
     * @param \StructType\ServicePrincipalCredential[] $servicePrincipalCredential
     */
    public function __construct(array $servicePrincipalCredential = array())
    {
        $this
            ->setServicePrincipalCredential($servicePrincipalCredential);
    }
    /**
     * Get ServicePrincipalCredential value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServicePrincipalCredential[]|null
     */
    public function getServicePrincipalCredential()
    {
        return isset($this->ServicePrincipalCredential) ? $this->ServicePrincipalCredential : null;
    }
    /**
     * Set ServicePrincipalCredential value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePrincipalCredential[] $servicePrincipalCredential
     * @return \ArrayType\ArrayOfServicePrincipalCredential
     */
    public function setServicePrincipalCredential(array $servicePrincipalCredential = array())
    {
        foreach ($servicePrincipalCredential as $arrayOfServicePrincipalCredentialServicePrincipalCredentialItem) {
            // validation for constraint: itemType
            if (!$arrayOfServicePrincipalCredentialServicePrincipalCredentialItem instanceof \StructType\ServicePrincipalCredential) {
                throw new \InvalidArgumentException(sprintf('The ServicePrincipalCredential property can only contain items of \StructType\ServicePrincipalCredential, "%s" given', is_object($arrayOfServicePrincipalCredentialServicePrincipalCredentialItem) ? get_class($arrayOfServicePrincipalCredentialServicePrincipalCredentialItem) : gettype($arrayOfServicePrincipalCredentialServicePrincipalCredentialItem)), __LINE__);
            }
        }
        if (is_null($servicePrincipalCredential) || (is_array($servicePrincipalCredential) && empty($servicePrincipalCredential))) {
            unset($this->ServicePrincipalCredential);
        } else {
            $this->ServicePrincipalCredential = $servicePrincipalCredential;
        }
        return $this;
    }
    /**
     * Add item to ServicePrincipalCredential value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePrincipalCredential $item
     * @return \ArrayType\ArrayOfServicePrincipalCredential
     */
    public function addToServicePrincipalCredential(\StructType\ServicePrincipalCredential $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServicePrincipalCredential) {
            throw new \InvalidArgumentException(sprintf('The ServicePrincipalCredential property can only contain items of \StructType\ServicePrincipalCredential, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServicePrincipalCredential[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServicePrincipalCredential|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServicePrincipalCredential|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServicePrincipalCredential|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServicePrincipalCredential|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServicePrincipalCredential|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServicePrincipalCredential
     */
    public function getAttributeName()
    {
        return 'ServicePrincipalCredential';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfServicePrincipalCredential
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
