<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStrongAuthenticationPhoneAppDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStrongAuthenticationPhoneAppDetail
 * @subpackage Arrays
 */
class ArrayOfStrongAuthenticationPhoneAppDetail extends AbstractStructArrayBase
{
    /**
     * The StrongAuthenticationPhoneAppDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StrongAuthenticationPhoneAppDetail[]
     */
    public $StrongAuthenticationPhoneAppDetail;
    /**
     * Constructor method for ArrayOfStrongAuthenticationPhoneAppDetail
     * @uses ArrayOfStrongAuthenticationPhoneAppDetail::setStrongAuthenticationPhoneAppDetail()
     * @param \StructType\StrongAuthenticationPhoneAppDetail[] $strongAuthenticationPhoneAppDetail
     */
    public function __construct(array $strongAuthenticationPhoneAppDetail = array())
    {
        $this
            ->setStrongAuthenticationPhoneAppDetail($strongAuthenticationPhoneAppDetail);
    }
    /**
     * Get StrongAuthenticationPhoneAppDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StrongAuthenticationPhoneAppDetail[]|null
     */
    public function getStrongAuthenticationPhoneAppDetail()
    {
        return isset($this->StrongAuthenticationPhoneAppDetail) ? $this->StrongAuthenticationPhoneAppDetail : null;
    }
    /**
     * Set StrongAuthenticationPhoneAppDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StrongAuthenticationPhoneAppDetail[] $strongAuthenticationPhoneAppDetail
     * @return \ArrayType\ArrayOfStrongAuthenticationPhoneAppDetail
     */
    public function setStrongAuthenticationPhoneAppDetail(array $strongAuthenticationPhoneAppDetail = array())
    {
        foreach ($strongAuthenticationPhoneAppDetail as $arrayOfStrongAuthenticationPhoneAppDetailStrongAuthenticationPhoneAppDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfStrongAuthenticationPhoneAppDetailStrongAuthenticationPhoneAppDetailItem instanceof \StructType\StrongAuthenticationPhoneAppDetail) {
                throw new \InvalidArgumentException(sprintf('The StrongAuthenticationPhoneAppDetail property can only contain items of \StructType\StrongAuthenticationPhoneAppDetail, "%s" given', is_object($arrayOfStrongAuthenticationPhoneAppDetailStrongAuthenticationPhoneAppDetailItem) ? get_class($arrayOfStrongAuthenticationPhoneAppDetailStrongAuthenticationPhoneAppDetailItem) : gettype($arrayOfStrongAuthenticationPhoneAppDetailStrongAuthenticationPhoneAppDetailItem)), __LINE__);
            }
        }
        if (is_null($strongAuthenticationPhoneAppDetail) || (is_array($strongAuthenticationPhoneAppDetail) && empty($strongAuthenticationPhoneAppDetail))) {
            unset($this->StrongAuthenticationPhoneAppDetail);
        } else {
            $this->StrongAuthenticationPhoneAppDetail = $strongAuthenticationPhoneAppDetail;
        }
        return $this;
    }
    /**
     * Add item to StrongAuthenticationPhoneAppDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\StrongAuthenticationPhoneAppDetail $item
     * @return \ArrayType\ArrayOfStrongAuthenticationPhoneAppDetail
     */
    public function addToStrongAuthenticationPhoneAppDetail(\StructType\StrongAuthenticationPhoneAppDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StrongAuthenticationPhoneAppDetail) {
            throw new \InvalidArgumentException(sprintf('The StrongAuthenticationPhoneAppDetail property can only contain items of \StructType\StrongAuthenticationPhoneAppDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StrongAuthenticationPhoneAppDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StrongAuthenticationPhoneAppDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StrongAuthenticationPhoneAppDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StrongAuthenticationPhoneAppDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StrongAuthenticationPhoneAppDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StrongAuthenticationPhoneAppDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StrongAuthenticationPhoneAppDetail
     */
    public function getAttributeName()
    {
        return 'StrongAuthenticationPhoneAppDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfStrongAuthenticationPhoneAppDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
