<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStrongAuthenticationRequirement ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStrongAuthenticationRequirement
 * @subpackage Arrays
 */
class ArrayOfStrongAuthenticationRequirement extends AbstractStructArrayBase
{
    /**
     * The StrongAuthenticationRequirement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StrongAuthenticationRequirement[]
     */
    public $StrongAuthenticationRequirement;
    /**
     * Constructor method for ArrayOfStrongAuthenticationRequirement
     * @uses ArrayOfStrongAuthenticationRequirement::setStrongAuthenticationRequirement()
     * @param \StructType\StrongAuthenticationRequirement[] $strongAuthenticationRequirement
     */
    public function __construct(array $strongAuthenticationRequirement = array())
    {
        $this
            ->setStrongAuthenticationRequirement($strongAuthenticationRequirement);
    }
    /**
     * Get StrongAuthenticationRequirement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StrongAuthenticationRequirement[]|null
     */
    public function getStrongAuthenticationRequirement()
    {
        return isset($this->StrongAuthenticationRequirement) ? $this->StrongAuthenticationRequirement : null;
    }
    /**
     * Set StrongAuthenticationRequirement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StrongAuthenticationRequirement[] $strongAuthenticationRequirement
     * @return \ArrayType\ArrayOfStrongAuthenticationRequirement
     */
    public function setStrongAuthenticationRequirement(array $strongAuthenticationRequirement = array())
    {
        foreach ($strongAuthenticationRequirement as $arrayOfStrongAuthenticationRequirementStrongAuthenticationRequirementItem) {
            // validation for constraint: itemType
            if (!$arrayOfStrongAuthenticationRequirementStrongAuthenticationRequirementItem instanceof \StructType\StrongAuthenticationRequirement) {
                throw new \InvalidArgumentException(sprintf('The StrongAuthenticationRequirement property can only contain items of \StructType\StrongAuthenticationRequirement, "%s" given', is_object($arrayOfStrongAuthenticationRequirementStrongAuthenticationRequirementItem) ? get_class($arrayOfStrongAuthenticationRequirementStrongAuthenticationRequirementItem) : gettype($arrayOfStrongAuthenticationRequirementStrongAuthenticationRequirementItem)), __LINE__);
            }
        }
        if (is_null($strongAuthenticationRequirement) || (is_array($strongAuthenticationRequirement) && empty($strongAuthenticationRequirement))) {
            unset($this->StrongAuthenticationRequirement);
        } else {
            $this->StrongAuthenticationRequirement = $strongAuthenticationRequirement;
        }
        return $this;
    }
    /**
     * Add item to StrongAuthenticationRequirement value
     * @throws \InvalidArgumentException
     * @param \StructType\StrongAuthenticationRequirement $item
     * @return \ArrayType\ArrayOfStrongAuthenticationRequirement
     */
    public function addToStrongAuthenticationRequirement(\StructType\StrongAuthenticationRequirement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StrongAuthenticationRequirement) {
            throw new \InvalidArgumentException(sprintf('The StrongAuthenticationRequirement property can only contain items of \StructType\StrongAuthenticationRequirement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StrongAuthenticationRequirement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StrongAuthenticationRequirement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StrongAuthenticationRequirement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StrongAuthenticationRequirement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StrongAuthenticationRequirement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StrongAuthenticationRequirement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StrongAuthenticationRequirement
     */
    public function getAttributeName()
    {
        return 'StrongAuthenticationRequirement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfStrongAuthenticationRequirement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
