<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Change ServiceType
 * @subpackage Services
 */
class Change extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ChangeUserPrincipalName
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ChangeUserPrincipalName $parameters
     * @return \StructType\ChangeUserPrincipalNameResponse|bool
     */
    public function ChangeUserPrincipalName(\StructType\ChangeUserPrincipalName $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ChangeUserPrincipalName($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ChangeUserPrincipalNameByUpn
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ChangeUserPrincipalNameByUpn $parameters
     * @return \StructType\ChangeUserPrincipalNameByUpnResponse|bool
     */
    public function ChangeUserPrincipalNameByUpn(\StructType\ChangeUserPrincipalNameByUpn $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ChangeUserPrincipalNameByUpn($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\ChangeUserPrincipalNameByUpnResponse|\StructType\ChangeUserPrincipalNameResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
