<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddWellKnownGroupRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AddWellKnownGroupRequest
 * @subpackage Structs
 */
class AddWellKnownGroupRequest extends Request
{
    /**
     * The WellKnownGroupName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WellKnownGroupName;
    /**
     * Constructor method for AddWellKnownGroupRequest
     * @uses AddWellKnownGroupRequest::setWellKnownGroupName()
     * @param string $wellKnownGroupName
     */
    public function __construct($wellKnownGroupName = null)
    {
        $this
            ->setWellKnownGroupName($wellKnownGroupName);
    }
    /**
     * Get WellKnownGroupName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWellKnownGroupName()
    {
        return isset($this->WellKnownGroupName) ? $this->WellKnownGroupName : null;
    }
    /**
     * Set WellKnownGroupName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $wellKnownGroupName
     * @return \StructType\AddWellKnownGroupRequest
     */
    public function setWellKnownGroupName($wellKnownGroupName = null)
    {
        // validation for constraint: string
        if (!is_null($wellKnownGroupName) && !is_string($wellKnownGroupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($wellKnownGroupName)), __LINE__);
        }
        if (is_null($wellKnownGroupName) || (is_array($wellKnownGroupName) && empty($wellKnownGroupName))) {
            unset($this->WellKnownGroupName);
        } else {
            $this->WellKnownGroupName = $wellKnownGroupName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddWellKnownGroupRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
