<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChangeUserPrincipalNameByUpnRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ChangeUserPrincipalNameByUpnRequest
 * @subpackage Structs
 */
class ChangeUserPrincipalNameByUpnRequest extends Request
{
    /**
     * The ImmutableId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ImmutableId;
    /**
     * The NewPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NewPassword;
    /**
     * The NewUserPrincipalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NewUserPrincipalName;
    /**
     * The UserPrincipalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserPrincipalName;
    /**
     * Constructor method for ChangeUserPrincipalNameByUpnRequest
     * @uses ChangeUserPrincipalNameByUpnRequest::setImmutableId()
     * @uses ChangeUserPrincipalNameByUpnRequest::setNewPassword()
     * @uses ChangeUserPrincipalNameByUpnRequest::setNewUserPrincipalName()
     * @uses ChangeUserPrincipalNameByUpnRequest::setUserPrincipalName()
     * @param string $immutableId
     * @param string $newPassword
     * @param string $newUserPrincipalName
     * @param string $userPrincipalName
     */
    public function __construct($immutableId = null, $newPassword = null, $newUserPrincipalName = null, $userPrincipalName = null)
    {
        $this
            ->setImmutableId($immutableId)
            ->setNewPassword($newPassword)
            ->setNewUserPrincipalName($newUserPrincipalName)
            ->setUserPrincipalName($userPrincipalName);
    }
    /**
     * Get ImmutableId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImmutableId()
    {
        return isset($this->ImmutableId) ? $this->ImmutableId : null;
    }
    /**
     * Set ImmutableId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $immutableId
     * @return \StructType\ChangeUserPrincipalNameByUpnRequest
     */
    public function setImmutableId($immutableId = null)
    {
        // validation for constraint: string
        if (!is_null($immutableId) && !is_string($immutableId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($immutableId)), __LINE__);
        }
        if (is_null($immutableId) || (is_array($immutableId) && empty($immutableId))) {
            unset($this->ImmutableId);
        } else {
            $this->ImmutableId = $immutableId;
        }
        return $this;
    }
    /**
     * Get NewPassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewPassword()
    {
        return isset($this->NewPassword) ? $this->NewPassword : null;
    }
    /**
     * Set NewPassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newPassword
     * @return \StructType\ChangeUserPrincipalNameByUpnRequest
     */
    public function setNewPassword($newPassword = null)
    {
        // validation for constraint: string
        if (!is_null($newPassword) && !is_string($newPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newPassword)), __LINE__);
        }
        if (is_null($newPassword) || (is_array($newPassword) && empty($newPassword))) {
            unset($this->NewPassword);
        } else {
            $this->NewPassword = $newPassword;
        }
        return $this;
    }
    /**
     * Get NewUserPrincipalName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewUserPrincipalName()
    {
        return isset($this->NewUserPrincipalName) ? $this->NewUserPrincipalName : null;
    }
    /**
     * Set NewUserPrincipalName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newUserPrincipalName
     * @return \StructType\ChangeUserPrincipalNameByUpnRequest
     */
    public function setNewUserPrincipalName($newUserPrincipalName = null)
    {
        // validation for constraint: string
        if (!is_null($newUserPrincipalName) && !is_string($newUserPrincipalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newUserPrincipalName)), __LINE__);
        }
        if (is_null($newUserPrincipalName) || (is_array($newUserPrincipalName) && empty($newUserPrincipalName))) {
            unset($this->NewUserPrincipalName);
        } else {
            $this->NewUserPrincipalName = $newUserPrincipalName;
        }
        return $this;
    }
    /**
     * Get UserPrincipalName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserPrincipalName()
    {
        return isset($this->UserPrincipalName) ? $this->UserPrincipalName : null;
    }
    /**
     * Set UserPrincipalName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userPrincipalName
     * @return \StructType\ChangeUserPrincipalNameByUpnRequest
     */
    public function setUserPrincipalName($userPrincipalName = null)
    {
        // validation for constraint: string
        if (!is_null($userPrincipalName) && !is_string($userPrincipalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userPrincipalName)), __LINE__);
        }
        if (is_null($userPrincipalName) || (is_array($userPrincipalName) && empty($userPrincipalName))) {
            unset($this->UserPrincipalName);
        } else {
            $this->UserPrincipalName = $userPrincipalName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChangeUserPrincipalNameByUpnRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
