<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompanySettings StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:CompanySettings
 * @subpackage Structs
 */
class CompanySettings extends AbstractStructBase
{
    /**
     * The AllowAdHocSubscriptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $AllowAdHocSubscriptions;
    /**
     * The AllowEmailVerifiedUsers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $AllowEmailVerifiedUsers;
    /**
     * The DefaultUsageLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DefaultUsageLocation;
    /**
     * The RmsViralSignUpEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $RmsViralSignUpEnabled;
    /**
     * The SelfServePasswordResetEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $SelfServePasswordResetEnabled;
    /**
     * The UsersPermissionToCreateGroupsEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $UsersPermissionToCreateGroupsEnabled;
    /**
     * The UsersPermissionToCreateLOBAppsEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $UsersPermissionToCreateLOBAppsEnabled;
    /**
     * The UsersPermissionToReadOtherUsersEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $UsersPermissionToReadOtherUsersEnabled;
    /**
     * The UsersPermissionToUserConsentToAppEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $UsersPermissionToUserConsentToAppEnabled;
    /**
     * Constructor method for CompanySettings
     * @uses CompanySettings::setAllowAdHocSubscriptions()
     * @uses CompanySettings::setAllowEmailVerifiedUsers()
     * @uses CompanySettings::setDefaultUsageLocation()
     * @uses CompanySettings::setRmsViralSignUpEnabled()
     * @uses CompanySettings::setSelfServePasswordResetEnabled()
     * @uses CompanySettings::setUsersPermissionToCreateGroupsEnabled()
     * @uses CompanySettings::setUsersPermissionToCreateLOBAppsEnabled()
     * @uses CompanySettings::setUsersPermissionToReadOtherUsersEnabled()
     * @uses CompanySettings::setUsersPermissionToUserConsentToAppEnabled()
     * @param bool $allowAdHocSubscriptions
     * @param bool $allowEmailVerifiedUsers
     * @param string $defaultUsageLocation
     * @param bool $rmsViralSignUpEnabled
     * @param bool $selfServePasswordResetEnabled
     * @param bool $usersPermissionToCreateGroupsEnabled
     * @param bool $usersPermissionToCreateLOBAppsEnabled
     * @param bool $usersPermissionToReadOtherUsersEnabled
     * @param bool $usersPermissionToUserConsentToAppEnabled
     */
    public function __construct($allowAdHocSubscriptions = null, $allowEmailVerifiedUsers = null, $defaultUsageLocation = null, $rmsViralSignUpEnabled = null, $selfServePasswordResetEnabled = null, $usersPermissionToCreateGroupsEnabled = null, $usersPermissionToCreateLOBAppsEnabled = null, $usersPermissionToReadOtherUsersEnabled = null, $usersPermissionToUserConsentToAppEnabled = null)
    {
        $this
            ->setAllowAdHocSubscriptions($allowAdHocSubscriptions)
            ->setAllowEmailVerifiedUsers($allowEmailVerifiedUsers)
            ->setDefaultUsageLocation($defaultUsageLocation)
            ->setRmsViralSignUpEnabled($rmsViralSignUpEnabled)
            ->setSelfServePasswordResetEnabled($selfServePasswordResetEnabled)
            ->setUsersPermissionToCreateGroupsEnabled($usersPermissionToCreateGroupsEnabled)
            ->setUsersPermissionToCreateLOBAppsEnabled($usersPermissionToCreateLOBAppsEnabled)
            ->setUsersPermissionToReadOtherUsersEnabled($usersPermissionToReadOtherUsersEnabled)
            ->setUsersPermissionToUserConsentToAppEnabled($usersPermissionToUserConsentToAppEnabled);
    }
    /**
     * Get AllowAdHocSubscriptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getAllowAdHocSubscriptions()
    {
        return isset($this->AllowAdHocSubscriptions) ? $this->AllowAdHocSubscriptions : null;
    }
    /**
     * Set AllowAdHocSubscriptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $allowAdHocSubscriptions
     * @return \StructType\CompanySettings
     */
    public function setAllowAdHocSubscriptions($allowAdHocSubscriptions = null)
    {
        if (is_null($allowAdHocSubscriptions) || (is_array($allowAdHocSubscriptions) && empty($allowAdHocSubscriptions))) {
            unset($this->AllowAdHocSubscriptions);
        } else {
            $this->AllowAdHocSubscriptions = $allowAdHocSubscriptions;
        }
        return $this;
    }
    /**
     * Get AllowEmailVerifiedUsers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getAllowEmailVerifiedUsers()
    {
        return isset($this->AllowEmailVerifiedUsers) ? $this->AllowEmailVerifiedUsers : null;
    }
    /**
     * Set AllowEmailVerifiedUsers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $allowEmailVerifiedUsers
     * @return \StructType\CompanySettings
     */
    public function setAllowEmailVerifiedUsers($allowEmailVerifiedUsers = null)
    {
        if (is_null($allowEmailVerifiedUsers) || (is_array($allowEmailVerifiedUsers) && empty($allowEmailVerifiedUsers))) {
            unset($this->AllowEmailVerifiedUsers);
        } else {
            $this->AllowEmailVerifiedUsers = $allowEmailVerifiedUsers;
        }
        return $this;
    }
    /**
     * Get DefaultUsageLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDefaultUsageLocation()
    {
        return isset($this->DefaultUsageLocation) ? $this->DefaultUsageLocation : null;
    }
    /**
     * Set DefaultUsageLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $defaultUsageLocation
     * @return \StructType\CompanySettings
     */
    public function setDefaultUsageLocation($defaultUsageLocation = null)
    {
        // validation for constraint: string
        if (!is_null($defaultUsageLocation) && !is_string($defaultUsageLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($defaultUsageLocation)), __LINE__);
        }
        if (is_null($defaultUsageLocation) || (is_array($defaultUsageLocation) && empty($defaultUsageLocation))) {
            unset($this->DefaultUsageLocation);
        } else {
            $this->DefaultUsageLocation = $defaultUsageLocation;
        }
        return $this;
    }
    /**
     * Get RmsViralSignUpEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getRmsViralSignUpEnabled()
    {
        return isset($this->RmsViralSignUpEnabled) ? $this->RmsViralSignUpEnabled : null;
    }
    /**
     * Set RmsViralSignUpEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $rmsViralSignUpEnabled
     * @return \StructType\CompanySettings
     */
    public function setRmsViralSignUpEnabled($rmsViralSignUpEnabled = null)
    {
        if (is_null($rmsViralSignUpEnabled) || (is_array($rmsViralSignUpEnabled) && empty($rmsViralSignUpEnabled))) {
            unset($this->RmsViralSignUpEnabled);
        } else {
            $this->RmsViralSignUpEnabled = $rmsViralSignUpEnabled;
        }
        return $this;
    }
    /**
     * Get SelfServePasswordResetEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSelfServePasswordResetEnabled()
    {
        return isset($this->SelfServePasswordResetEnabled) ? $this->SelfServePasswordResetEnabled : null;
    }
    /**
     * Set SelfServePasswordResetEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $selfServePasswordResetEnabled
     * @return \StructType\CompanySettings
     */
    public function setSelfServePasswordResetEnabled($selfServePasswordResetEnabled = null)
    {
        if (is_null($selfServePasswordResetEnabled) || (is_array($selfServePasswordResetEnabled) && empty($selfServePasswordResetEnabled))) {
            unset($this->SelfServePasswordResetEnabled);
        } else {
            $this->SelfServePasswordResetEnabled = $selfServePasswordResetEnabled;
        }
        return $this;
    }
    /**
     * Get UsersPermissionToCreateGroupsEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getUsersPermissionToCreateGroupsEnabled()
    {
        return isset($this->UsersPermissionToCreateGroupsEnabled) ? $this->UsersPermissionToCreateGroupsEnabled : null;
    }
    /**
     * Set UsersPermissionToCreateGroupsEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $usersPermissionToCreateGroupsEnabled
     * @return \StructType\CompanySettings
     */
    public function setUsersPermissionToCreateGroupsEnabled($usersPermissionToCreateGroupsEnabled = null)
    {
        if (is_null($usersPermissionToCreateGroupsEnabled) || (is_array($usersPermissionToCreateGroupsEnabled) && empty($usersPermissionToCreateGroupsEnabled))) {
            unset($this->UsersPermissionToCreateGroupsEnabled);
        } else {
            $this->UsersPermissionToCreateGroupsEnabled = $usersPermissionToCreateGroupsEnabled;
        }
        return $this;
    }
    /**
     * Get UsersPermissionToCreateLOBAppsEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getUsersPermissionToCreateLOBAppsEnabled()
    {
        return isset($this->UsersPermissionToCreateLOBAppsEnabled) ? $this->UsersPermissionToCreateLOBAppsEnabled : null;
    }
    /**
     * Set UsersPermissionToCreateLOBAppsEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $usersPermissionToCreateLOBAppsEnabled
     * @return \StructType\CompanySettings
     */
    public function setUsersPermissionToCreateLOBAppsEnabled($usersPermissionToCreateLOBAppsEnabled = null)
    {
        if (is_null($usersPermissionToCreateLOBAppsEnabled) || (is_array($usersPermissionToCreateLOBAppsEnabled) && empty($usersPermissionToCreateLOBAppsEnabled))) {
            unset($this->UsersPermissionToCreateLOBAppsEnabled);
        } else {
            $this->UsersPermissionToCreateLOBAppsEnabled = $usersPermissionToCreateLOBAppsEnabled;
        }
        return $this;
    }
    /**
     * Get UsersPermissionToReadOtherUsersEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getUsersPermissionToReadOtherUsersEnabled()
    {
        return isset($this->UsersPermissionToReadOtherUsersEnabled) ? $this->UsersPermissionToReadOtherUsersEnabled : null;
    }
    /**
     * Set UsersPermissionToReadOtherUsersEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $usersPermissionToReadOtherUsersEnabled
     * @return \StructType\CompanySettings
     */
    public function setUsersPermissionToReadOtherUsersEnabled($usersPermissionToReadOtherUsersEnabled = null)
    {
        if (is_null($usersPermissionToReadOtherUsersEnabled) || (is_array($usersPermissionToReadOtherUsersEnabled) && empty($usersPermissionToReadOtherUsersEnabled))) {
            unset($this->UsersPermissionToReadOtherUsersEnabled);
        } else {
            $this->UsersPermissionToReadOtherUsersEnabled = $usersPermissionToReadOtherUsersEnabled;
        }
        return $this;
    }
    /**
     * Get UsersPermissionToUserConsentToAppEnabled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getUsersPermissionToUserConsentToAppEnabled()
    {
        return isset($this->UsersPermissionToUserConsentToAppEnabled) ? $this->UsersPermissionToUserConsentToAppEnabled : null;
    }
    /**
     * Set UsersPermissionToUserConsentToAppEnabled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $usersPermissionToUserConsentToAppEnabled
     * @return \StructType\CompanySettings
     */
    public function setUsersPermissionToUserConsentToAppEnabled($usersPermissionToUserConsentToAppEnabled = null)
    {
        if (is_null($usersPermissionToUserConsentToAppEnabled) || (is_array($usersPermissionToUserConsentToAppEnabled) && empty($usersPermissionToUserConsentToAppEnabled))) {
            unset($this->UsersPermissionToUserConsentToAppEnabled);
        } else {
            $this->UsersPermissionToUserConsentToAppEnabled = $usersPermissionToUserConsentToAppEnabled;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CompanySettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
