<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactSearchDefinition StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ContactSearchDefinition
 * @subpackage Structs
 */
class ContactSearchDefinition extends SearchDefinition
{
    /**
     * The HasErrorsOnly
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $HasErrorsOnly;
    /**
     * The IncludedProperties
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $IncludedProperties;
    /**
     * Constructor method for ContactSearchDefinition
     * @uses ContactSearchDefinition::setHasErrorsOnly()
     * @uses ContactSearchDefinition::setIncludedProperties()
     * @param bool $hasErrorsOnly
     * @param \ArrayType\ArrayOfstring $includedProperties
     */
    public function __construct($hasErrorsOnly = null, \ArrayType\ArrayOfstring $includedProperties = null)
    {
        $this
            ->setHasErrorsOnly($hasErrorsOnly)
            ->setIncludedProperties($includedProperties);
    }
    /**
     * Get HasErrorsOnly value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getHasErrorsOnly()
    {
        return isset($this->HasErrorsOnly) ? $this->HasErrorsOnly : null;
    }
    /**
     * Set HasErrorsOnly value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $hasErrorsOnly
     * @return \StructType\ContactSearchDefinition
     */
    public function setHasErrorsOnly($hasErrorsOnly = null)
    {
        if (is_null($hasErrorsOnly) || (is_array($hasErrorsOnly) && empty($hasErrorsOnly))) {
            unset($this->HasErrorsOnly);
        } else {
            $this->HasErrorsOnly = $hasErrorsOnly;
        }
        return $this;
    }
    /**
     * Get IncludedProperties value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getIncludedProperties()
    {
        return isset($this->IncludedProperties) ? $this->IncludedProperties : null;
    }
    /**
     * Set IncludedProperties value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $includedProperties
     * @return \StructType\ContactSearchDefinition
     */
    public function setIncludedProperties(\ArrayType\ArrayOfstring $includedProperties = null)
    {
        if (is_null($includedProperties) || (is_array($includedProperties) && empty($includedProperties))) {
            unset($this->IncludedProperties);
        } else {
            $this->IncludedProperties = $includedProperties;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactSearchDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
