<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DirSyncFeatureDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DirSyncFeatureDetails
 * @subpackage Structs
 */
class DirSyncFeatureDetails extends AbstractStructBase
{
    /**
     * The DirSyncFeature
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DirSyncFeature;
    /**
     * The Enabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Enabled;
    /**
     * Constructor method for DirSyncFeatureDetails
     * @uses DirSyncFeatureDetails::setDirSyncFeature()
     * @uses DirSyncFeatureDetails::setEnabled()
     * @param string $dirSyncFeature
     * @param bool $enabled
     */
    public function __construct($dirSyncFeature = null, $enabled = null)
    {
        $this
            ->setDirSyncFeature($dirSyncFeature)
            ->setEnabled($enabled);
    }
    /**
     * Get DirSyncFeature value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDirSyncFeature()
    {
        return isset($this->DirSyncFeature) ? $this->DirSyncFeature : null;
    }
    /**
     * Set DirSyncFeature value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dirSyncFeature
     * @return \StructType\DirSyncFeatureDetails
     */
    public function setDirSyncFeature($dirSyncFeature = null)
    {
        // validation for constraint: string
        if (!is_null($dirSyncFeature) && !is_string($dirSyncFeature)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dirSyncFeature)), __LINE__);
        }
        if (is_null($dirSyncFeature) || (is_array($dirSyncFeature) && empty($dirSyncFeature))) {
            unset($this->DirSyncFeature);
        } else {
            $this->DirSyncFeature = $dirSyncFeature;
        }
        return $this;
    }
    /**
     * Get Enabled value
     * @return bool|null
     */
    public function getEnabled()
    {
        return $this->Enabled;
    }
    /**
     * Set Enabled value
     * @param bool $enabled
     * @return \StructType\DirSyncFeatureDetails
     */
    public function setEnabled($enabled = null)
    {
        $this->Enabled = $enabled;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DirSyncFeatureDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
