<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DirSyncProvisioningErrorSearchDefinition StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DirSyncProvisioningErrorSearchDefinition
 * @subpackage Structs
 */
class DirSyncProvisioningErrorSearchDefinition extends SearchDefinition
{
    /**
     * The ErrorCategory
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorCategory;
    /**
     * The ObjectType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ObjectType;
    /**
     * The PropertyName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PropertyName;
    /**
     * The PropertyValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PropertyValue;
    /**
     * Constructor method for DirSyncProvisioningErrorSearchDefinition
     * @uses DirSyncProvisioningErrorSearchDefinition::setErrorCategory()
     * @uses DirSyncProvisioningErrorSearchDefinition::setObjectType()
     * @uses DirSyncProvisioningErrorSearchDefinition::setPropertyName()
     * @uses DirSyncProvisioningErrorSearchDefinition::setPropertyValue()
     * @param string $errorCategory
     * @param string $objectType
     * @param string $propertyName
     * @param string $propertyValue
     */
    public function __construct($errorCategory = null, $objectType = null, $propertyName = null, $propertyValue = null)
    {
        $this
            ->setErrorCategory($errorCategory)
            ->setObjectType($objectType)
            ->setPropertyName($propertyName)
            ->setPropertyValue($propertyValue);
    }
    /**
     * Get ErrorCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorCategory()
    {
        return isset($this->ErrorCategory) ? $this->ErrorCategory : null;
    }
    /**
     * Set ErrorCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorCategory
     * @return \StructType\DirSyncProvisioningErrorSearchDefinition
     */
    public function setErrorCategory($errorCategory = null)
    {
        // validation for constraint: string
        if (!is_null($errorCategory) && !is_string($errorCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorCategory)), __LINE__);
        }
        if (is_null($errorCategory) || (is_array($errorCategory) && empty($errorCategory))) {
            unset($this->ErrorCategory);
        } else {
            $this->ErrorCategory = $errorCategory;
        }
        return $this;
    }
    /**
     * Get ObjectType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getObjectType()
    {
        return isset($this->ObjectType) ? $this->ObjectType : null;
    }
    /**
     * Set ObjectType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $objectType
     * @return \StructType\DirSyncProvisioningErrorSearchDefinition
     */
    public function setObjectType($objectType = null)
    {
        // validation for constraint: string
        if (!is_null($objectType) && !is_string($objectType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($objectType)), __LINE__);
        }
        if (is_null($objectType) || (is_array($objectType) && empty($objectType))) {
            unset($this->ObjectType);
        } else {
            $this->ObjectType = $objectType;
        }
        return $this;
    }
    /**
     * Get PropertyName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPropertyName()
    {
        return isset($this->PropertyName) ? $this->PropertyName : null;
    }
    /**
     * Set PropertyName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $propertyName
     * @return \StructType\DirSyncProvisioningErrorSearchDefinition
     */
    public function setPropertyName($propertyName = null)
    {
        // validation for constraint: string
        if (!is_null($propertyName) && !is_string($propertyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($propertyName)), __LINE__);
        }
        if (is_null($propertyName) || (is_array($propertyName) && empty($propertyName))) {
            unset($this->PropertyName);
        } else {
            $this->PropertyName = $propertyName;
        }
        return $this;
    }
    /**
     * Get PropertyValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPropertyValue()
    {
        return isset($this->PropertyValue) ? $this->PropertyValue : null;
    }
    /**
     * Set PropertyValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $propertyValue
     * @return \StructType\DirSyncProvisioningErrorSearchDefinition
     */
    public function setPropertyValue($propertyValue = null)
    {
        // validation for constraint: string
        if (!is_null($propertyValue) && !is_string($propertyValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($propertyValue)), __LINE__);
        }
        if (is_null($propertyValue) || (is_array($propertyValue) && empty($propertyValue))) {
            unset($this->PropertyValue);
        } else {
            $this->PropertyValue = $propertyValue;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DirSyncProvisioningErrorSearchDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
