<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DomainCapabilitySetException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DomainCapabilitySetException
 * @subpackage Structs
 */
class DomainCapabilitySetException extends DomainDataOperationException
{
    /**
     * The Capability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Capability;
    /**
     * Constructor method for DomainCapabilitySetException
     * @uses DomainCapabilitySetException::setCapability()
     * @param string $capability
     */
    public function __construct($capability = null)
    {
        $this
            ->setCapability($capability);
    }
    /**
     * Get Capability value
     * @return string|null
     */
    public function getCapability()
    {
        return $this->Capability;
    }
    /**
     * Set Capability value
     * @uses \EnumType\DomainCapabilities::valueIsValid()
     * @uses \EnumType\DomainCapabilities::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $capability
     * @return \StructType\DomainCapabilitySetException
     */
    public function setCapability($capability = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DomainCapabilities::valueIsValid($capability)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $capability, implode(', ', \EnumType\DomainCapabilities::getValidValues())), __LINE__);
        }
        $this->Capability = $capability;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DomainCapabilitySetException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
