<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DomainDnsNullRecord StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DomainDnsNullRecord
 * @subpackage Structs
 */
class DomainDnsNullRecord extends DomainDnsRecord
{
    /**
     * The Error
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * Constructor method for DomainDnsNullRecord
     * @uses DomainDnsNullRecord::setError()
     * @param string $error
     */
    public function __construct($error = null)
    {
        $this
            ->setError($error);
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @uses \EnumType\DomainDnsRecordError::valueIsValid()
     * @uses \EnumType\DomainDnsRecordError::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $error
     * @return \StructType\DomainDnsNullRecord
     */
    public function setError($error = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DomainDnsRecordError::valueIsValid($error)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $error, implode(', ', \EnumType\DomainDnsRecordError::getValidValues())), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DomainDnsNullRecord
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
