<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmailVerifiedDomainInformation StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:EmailVerifiedDomainInformation
 * @subpackage Structs
 */
class EmailVerifiedDomainInformation extends AbstractStructBase
{
    /**
     * The MoreUsers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $MoreUsers;
    /**
     * The UserCount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $UserCount;
    /**
     * Constructor method for EmailVerifiedDomainInformation
     * @uses EmailVerifiedDomainInformation::setMoreUsers()
     * @uses EmailVerifiedDomainInformation::setUserCount()
     * @param bool $moreUsers
     * @param int $userCount
     */
    public function __construct($moreUsers = null, $userCount = null)
    {
        $this
            ->setMoreUsers($moreUsers)
            ->setUserCount($userCount);
    }
    /**
     * Get MoreUsers value
     * @return bool|null
     */
    public function getMoreUsers()
    {
        return $this->MoreUsers;
    }
    /**
     * Set MoreUsers value
     * @param bool $moreUsers
     * @return \StructType\EmailVerifiedDomainInformation
     */
    public function setMoreUsers($moreUsers = null)
    {
        $this->MoreUsers = $moreUsers;
        return $this;
    }
    /**
     * Get UserCount value
     * @return int|null
     */
    public function getUserCount()
    {
        return $this->UserCount;
    }
    /**
     * Set UserCount value
     * @param int $userCount
     * @return \StructType\EmailVerifiedDomainInformation
     */
    public function setUserCount($userCount = null)
    {
        // validation for constraint: int
        if (!is_null($userCount) && !is_numeric($userCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userCount)), __LINE__);
        }
        $this->UserCount = $userCount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EmailVerifiedDomainInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
