<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetHeaderInfoResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GetHeaderInfoResponse
 * @subpackage Structs
 */
class GetHeaderInfoResponse extends Response
{
    /**
     * The ClientVersionHeader
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClientVersionHeader
     */
    public $ClientVersionHeader;
    /**
     * The ClientVersionHeaderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ClientVersionHeaderName;
    /**
     * The ContextHeader
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Context
     */
    public $ContextHeader;
    /**
     * The ContextHeaderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContextHeaderName;
    /**
     * The ContractVersionHeader
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ContractVersionHeader
     */
    public $ContractVersionHeader;
    /**
     * The ContractVersionHeaderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContractVersionHeaderName;
    /**
     * The HeaderNameSpace
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HeaderNameSpace;
    /**
     * The IdentityHeaderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentityHeaderName;
    /**
     * The ReturnValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserIdentityHeader
     */
    public $ReturnValue;
    /**
     * The TrackingHeader
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrackingHeader
     */
    public $TrackingHeader;
    /**
     * The TrackingHeaderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TrackingHeaderName;
    /**
     * The GetHeaderInfoResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetHeaderInfoResponse
     */
    public $GetHeaderInfoResult;
    /**
     * Constructor method for GetHeaderInfoResponse
     * @uses GetHeaderInfoResponse::setClientVersionHeader()
     * @uses GetHeaderInfoResponse::setClientVersionHeaderName()
     * @uses GetHeaderInfoResponse::setContextHeader()
     * @uses GetHeaderInfoResponse::setContextHeaderName()
     * @uses GetHeaderInfoResponse::setContractVersionHeader()
     * @uses GetHeaderInfoResponse::setContractVersionHeaderName()
     * @uses GetHeaderInfoResponse::setHeaderNameSpace()
     * @uses GetHeaderInfoResponse::setIdentityHeaderName()
     * @uses GetHeaderInfoResponse::setReturnValue()
     * @uses GetHeaderInfoResponse::setTrackingHeader()
     * @uses GetHeaderInfoResponse::setTrackingHeaderName()
     * @uses GetHeaderInfoResponse::setGetHeaderInfoResult()
     * @param \StructType\ClientVersionHeader $clientVersionHeader
     * @param string $clientVersionHeaderName
     * @param \StructType\Context $contextHeader
     * @param string $contextHeaderName
     * @param \StructType\ContractVersionHeader $contractVersionHeader
     * @param string $contractVersionHeaderName
     * @param string $headerNameSpace
     * @param string $identityHeaderName
     * @param \StructType\UserIdentityHeader $returnValue
     * @param \StructType\TrackingHeader $trackingHeader
     * @param string $trackingHeaderName
     * @param \StructType\GetHeaderInfoResponse $getHeaderInfoResult
     */
    public function __construct(\StructType\ClientVersionHeader $clientVersionHeader = null, $clientVersionHeaderName = null, \StructType\Context $contextHeader = null, $contextHeaderName = null, \StructType\ContractVersionHeader $contractVersionHeader = null, $contractVersionHeaderName = null, $headerNameSpace = null, $identityHeaderName = null, \StructType\UserIdentityHeader $returnValue = null, \StructType\TrackingHeader $trackingHeader = null, $trackingHeaderName = null, \StructType\GetHeaderInfoResponse $getHeaderInfoResult = null)
    {
        $this
            ->setClientVersionHeader($clientVersionHeader)
            ->setClientVersionHeaderName($clientVersionHeaderName)
            ->setContextHeader($contextHeader)
            ->setContextHeaderName($contextHeaderName)
            ->setContractVersionHeader($contractVersionHeader)
            ->setContractVersionHeaderName($contractVersionHeaderName)
            ->setHeaderNameSpace($headerNameSpace)
            ->setIdentityHeaderName($identityHeaderName)
            ->setReturnValue($returnValue)
            ->setTrackingHeader($trackingHeader)
            ->setTrackingHeaderName($trackingHeaderName)
            ->setGetHeaderInfoResult($getHeaderInfoResult);
    }
    /**
     * Get ClientVersionHeader value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClientVersionHeader|null
     */
    public function getClientVersionHeader()
    {
        return isset($this->ClientVersionHeader) ? $this->ClientVersionHeader : null;
    }
    /**
     * Set ClientVersionHeader value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ClientVersionHeader $clientVersionHeader
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setClientVersionHeader(\StructType\ClientVersionHeader $clientVersionHeader = null)
    {
        if (is_null($clientVersionHeader) || (is_array($clientVersionHeader) && empty($clientVersionHeader))) {
            unset($this->ClientVersionHeader);
        } else {
            $this->ClientVersionHeader = $clientVersionHeader;
        }
        return $this;
    }
    /**
     * Get ClientVersionHeaderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getClientVersionHeaderName()
    {
        return isset($this->ClientVersionHeaderName) ? $this->ClientVersionHeaderName : null;
    }
    /**
     * Set ClientVersionHeaderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $clientVersionHeaderName
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setClientVersionHeaderName($clientVersionHeaderName = null)
    {
        // validation for constraint: string
        if (!is_null($clientVersionHeaderName) && !is_string($clientVersionHeaderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($clientVersionHeaderName)), __LINE__);
        }
        if (is_null($clientVersionHeaderName) || (is_array($clientVersionHeaderName) && empty($clientVersionHeaderName))) {
            unset($this->ClientVersionHeaderName);
        } else {
            $this->ClientVersionHeaderName = $clientVersionHeaderName;
        }
        return $this;
    }
    /**
     * Get ContextHeader value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Context|null
     */
    public function getContextHeader()
    {
        return isset($this->ContextHeader) ? $this->ContextHeader : null;
    }
    /**
     * Set ContextHeader value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Context $contextHeader
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setContextHeader(\StructType\Context $contextHeader = null)
    {
        if (is_null($contextHeader) || (is_array($contextHeader) && empty($contextHeader))) {
            unset($this->ContextHeader);
        } else {
            $this->ContextHeader = $contextHeader;
        }
        return $this;
    }
    /**
     * Get ContextHeaderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContextHeaderName()
    {
        return isset($this->ContextHeaderName) ? $this->ContextHeaderName : null;
    }
    /**
     * Set ContextHeaderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contextHeaderName
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setContextHeaderName($contextHeaderName = null)
    {
        // validation for constraint: string
        if (!is_null($contextHeaderName) && !is_string($contextHeaderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contextHeaderName)), __LINE__);
        }
        if (is_null($contextHeaderName) || (is_array($contextHeaderName) && empty($contextHeaderName))) {
            unset($this->ContextHeaderName);
        } else {
            $this->ContextHeaderName = $contextHeaderName;
        }
        return $this;
    }
    /**
     * Get ContractVersionHeader value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ContractVersionHeader|null
     */
    public function getContractVersionHeader()
    {
        return isset($this->ContractVersionHeader) ? $this->ContractVersionHeader : null;
    }
    /**
     * Set ContractVersionHeader value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ContractVersionHeader $contractVersionHeader
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setContractVersionHeader(\StructType\ContractVersionHeader $contractVersionHeader = null)
    {
        if (is_null($contractVersionHeader) || (is_array($contractVersionHeader) && empty($contractVersionHeader))) {
            unset($this->ContractVersionHeader);
        } else {
            $this->ContractVersionHeader = $contractVersionHeader;
        }
        return $this;
    }
    /**
     * Get ContractVersionHeaderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContractVersionHeaderName()
    {
        return isset($this->ContractVersionHeaderName) ? $this->ContractVersionHeaderName : null;
    }
    /**
     * Set ContractVersionHeaderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contractVersionHeaderName
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setContractVersionHeaderName($contractVersionHeaderName = null)
    {
        // validation for constraint: string
        if (!is_null($contractVersionHeaderName) && !is_string($contractVersionHeaderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contractVersionHeaderName)), __LINE__);
        }
        if (is_null($contractVersionHeaderName) || (is_array($contractVersionHeaderName) && empty($contractVersionHeaderName))) {
            unset($this->ContractVersionHeaderName);
        } else {
            $this->ContractVersionHeaderName = $contractVersionHeaderName;
        }
        return $this;
    }
    /**
     * Get HeaderNameSpace value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHeaderNameSpace()
    {
        return isset($this->HeaderNameSpace) ? $this->HeaderNameSpace : null;
    }
    /**
     * Set HeaderNameSpace value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $headerNameSpace
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setHeaderNameSpace($headerNameSpace = null)
    {
        // validation for constraint: string
        if (!is_null($headerNameSpace) && !is_string($headerNameSpace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerNameSpace)), __LINE__);
        }
        if (is_null($headerNameSpace) || (is_array($headerNameSpace) && empty($headerNameSpace))) {
            unset($this->HeaderNameSpace);
        } else {
            $this->HeaderNameSpace = $headerNameSpace;
        }
        return $this;
    }
    /**
     * Get IdentityHeaderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentityHeaderName()
    {
        return isset($this->IdentityHeaderName) ? $this->IdentityHeaderName : null;
    }
    /**
     * Set IdentityHeaderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identityHeaderName
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setIdentityHeaderName($identityHeaderName = null)
    {
        // validation for constraint: string
        if (!is_null($identityHeaderName) && !is_string($identityHeaderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identityHeaderName)), __LINE__);
        }
        if (is_null($identityHeaderName) || (is_array($identityHeaderName) && empty($identityHeaderName))) {
            unset($this->IdentityHeaderName);
        } else {
            $this->IdentityHeaderName = $identityHeaderName;
        }
        return $this;
    }
    /**
     * Get ReturnValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserIdentityHeader|null
     */
    public function getReturnValue()
    {
        return isset($this->ReturnValue) ? $this->ReturnValue : null;
    }
    /**
     * Set ReturnValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserIdentityHeader $returnValue
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setReturnValue(\StructType\UserIdentityHeader $returnValue = null)
    {
        if (is_null($returnValue) || (is_array($returnValue) && empty($returnValue))) {
            unset($this->ReturnValue);
        } else {
            $this->ReturnValue = $returnValue;
        }
        return $this;
    }
    /**
     * Get TrackingHeader value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrackingHeader|null
     */
    public function getTrackingHeader()
    {
        return isset($this->TrackingHeader) ? $this->TrackingHeader : null;
    }
    /**
     * Set TrackingHeader value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TrackingHeader $trackingHeader
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setTrackingHeader(\StructType\TrackingHeader $trackingHeader = null)
    {
        if (is_null($trackingHeader) || (is_array($trackingHeader) && empty($trackingHeader))) {
            unset($this->TrackingHeader);
        } else {
            $this->TrackingHeader = $trackingHeader;
        }
        return $this;
    }
    /**
     * Get TrackingHeaderName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTrackingHeaderName()
    {
        return isset($this->TrackingHeaderName) ? $this->TrackingHeaderName : null;
    }
    /**
     * Set TrackingHeaderName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $trackingHeaderName
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setTrackingHeaderName($trackingHeaderName = null)
    {
        // validation for constraint: string
        if (!is_null($trackingHeaderName) && !is_string($trackingHeaderName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingHeaderName)), __LINE__);
        }
        if (is_null($trackingHeaderName) || (is_array($trackingHeaderName) && empty($trackingHeaderName))) {
            unset($this->TrackingHeaderName);
        } else {
            $this->TrackingHeaderName = $trackingHeaderName;
        }
        return $this;
    }
    /**
     * Get GetHeaderInfoResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetHeaderInfoResponse|null
     */
    public function getGetHeaderInfoResult()
    {
        return isset($this->GetHeaderInfoResult) ? $this->GetHeaderInfoResult : null;
    }
    /**
     * Set GetHeaderInfoResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\GetHeaderInfoResponse $getHeaderInfoResult
     * @return \StructType\GetHeaderInfoResponse
     */
    public function setGetHeaderInfoResult(\StructType\GetHeaderInfoResponse $getHeaderInfoResult = null)
    {
        if (is_null($getHeaderInfoResult) || (is_array($getHeaderInfoResult) && empty($getHeaderInfoResult))) {
            unset($this->GetHeaderInfoResult);
        } else {
            $this->GetHeaderInfoResult = $getHeaderInfoResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetHeaderInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
