<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KeyNotFoundException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:KeyNotFoundException
 * @subpackage Structs
 */
class KeyNotFoundException extends ObjectNotFoundException
{
    /**
     * The InvalidKeys
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $InvalidKeys;
    /**
     * Constructor method for KeyNotFoundException
     * @uses KeyNotFoundException::setInvalidKeys()
     * @param \ArrayType\ArrayOfstring $invalidKeys
     */
    public function __construct(\ArrayType\ArrayOfstring $invalidKeys = null)
    {
        $this
            ->setInvalidKeys($invalidKeys);
    }
    /**
     * Get InvalidKeys value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getInvalidKeys()
    {
        return isset($this->InvalidKeys) ? $this->InvalidKeys : null;
    }
    /**
     * Set InvalidKeys value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $invalidKeys
     * @return \StructType\KeyNotFoundException
     */
    public function setInvalidKeys(\ArrayType\ArrayOfstring $invalidKeys = null)
    {
        if (is_null($invalidKeys) || (is_array($invalidKeys) && empty($invalidKeys))) {
            unset($this->InvalidKeys);
        } else {
            $this->InvalidKeys = $invalidKeys;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KeyNotFoundException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
