<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListDomainsRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ListDomainsRequest
 * @subpackage Structs
 */
class ListDomainsRequest extends Request
{
    /**
     * The SearchFilter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DomainSearchFilter
     */
    public $SearchFilter;
    /**
     * Constructor method for ListDomainsRequest
     * @uses ListDomainsRequest::setSearchFilter()
     * @param \StructType\DomainSearchFilter $searchFilter
     */
    public function __construct(\StructType\DomainSearchFilter $searchFilter = null)
    {
        $this
            ->setSearchFilter($searchFilter);
    }
    /**
     * Get SearchFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DomainSearchFilter|null
     */
    public function getSearchFilter()
    {
        return isset($this->SearchFilter) ? $this->SearchFilter : null;
    }
    /**
     * Set SearchFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DomainSearchFilter $searchFilter
     * @return \StructType\ListDomainsRequest
     */
    public function setSearchFilter(\StructType\DomainSearchFilter $searchFilter = null)
    {
        if (is_null($searchFilter) || (is_array($searchFilter) && empty($searchFilter))) {
            unset($this->SearchFilter);
        } else {
            $this->SearchFilter = $searchFilter;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListDomainsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
