<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListUsersRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ListUsersRequest
 * @subpackage Structs
 */
class ListUsersRequest extends Request
{
    /**
     * The UserSearchDefinition
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserSearchDefinition
     */
    public $UserSearchDefinition;
    /**
     * Constructor method for ListUsersRequest
     * @uses ListUsersRequest::setUserSearchDefinition()
     * @param \StructType\UserSearchDefinition $userSearchDefinition
     */
    public function __construct(\StructType\UserSearchDefinition $userSearchDefinition = null)
    {
        $this
            ->setUserSearchDefinition($userSearchDefinition);
    }
    /**
     * Get UserSearchDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserSearchDefinition|null
     */
    public function getUserSearchDefinition()
    {
        return isset($this->UserSearchDefinition) ? $this->UserSearchDefinition : null;
    }
    /**
     * Set UserSearchDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserSearchDefinition $userSearchDefinition
     * @return \StructType\ListUsersRequest
     */
    public function setUserSearchDefinition(\StructType\UserSearchDefinition $userSearchDefinition = null)
    {
        if (is_null($userSearchDefinition) || (is_array($userSearchDefinition) && empty($userSearchDefinition))) {
            unset($this->UserSearchDefinition);
        } else {
            $this->UserSearchDefinition = $userSearchDefinition;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListUsersRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
