<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NetworkSyntheticFault StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:NetworkSyntheticFault
 * @subpackage Structs
 */
class NetworkSyntheticFault extends AbstractStructBase
{
    /**
     * The ComponentName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ComponentName;
    /**
     * The ErrorDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorDescription;
    /**
     * The ServerName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ServerName;
    /**
     * Constructor method for NetworkSyntheticFault
     * @uses NetworkSyntheticFault::setComponentName()
     * @uses NetworkSyntheticFault::setErrorDescription()
     * @uses NetworkSyntheticFault::setServerName()
     * @param string $componentName
     * @param string $errorDescription
     * @param string $serverName
     */
    public function __construct($componentName = null, $errorDescription = null, $serverName = null)
    {
        $this
            ->setComponentName($componentName)
            ->setErrorDescription($errorDescription)
            ->setServerName($serverName);
    }
    /**
     * Get ComponentName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComponentName()
    {
        return isset($this->ComponentName) ? $this->ComponentName : null;
    }
    /**
     * Set ComponentName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $componentName
     * @return \StructType\NetworkSyntheticFault
     */
    public function setComponentName($componentName = null)
    {
        // validation for constraint: string
        if (!is_null($componentName) && !is_string($componentName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($componentName)), __LINE__);
        }
        if (is_null($componentName) || (is_array($componentName) && empty($componentName))) {
            unset($this->ComponentName);
        } else {
            $this->ComponentName = $componentName;
        }
        return $this;
    }
    /**
     * Get ErrorDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorDescription()
    {
        return isset($this->ErrorDescription) ? $this->ErrorDescription : null;
    }
    /**
     * Set ErrorDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorDescription
     * @return \StructType\NetworkSyntheticFault
     */
    public function setErrorDescription($errorDescription = null)
    {
        // validation for constraint: string
        if (!is_null($errorDescription) && !is_string($errorDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorDescription)), __LINE__);
        }
        if (is_null($errorDescription) || (is_array($errorDescription) && empty($errorDescription))) {
            unset($this->ErrorDescription);
        } else {
            $this->ErrorDescription = $errorDescription;
        }
        return $this;
    }
    /**
     * Get ServerName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServerName()
    {
        return isset($this->ServerName) ? $this->ServerName : null;
    }
    /**
     * Set ServerName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serverName
     * @return \StructType\NetworkSyntheticFault
     */
    public function setServerName($serverName = null)
    {
        // validation for constraint: string
        if (!is_null($serverName) && !is_string($serverName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serverName)), __LINE__);
        }
        if (is_null($serverName) || (is_array($serverName) && empty($serverName))) {
            unset($this->ServerName);
        } else {
            $this->ServerName = $serverName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NetworkSyntheticFault
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
