<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObjectAlreadyExistsException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ObjectAlreadyExistsException
 * @subpackage Structs
 */
class ObjectAlreadyExistsException extends DataOperationException
{
    /**
     * The ObjectKey
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ObjectKey;
    /**
     * Constructor method for ObjectAlreadyExistsException
     * @uses ObjectAlreadyExistsException::setObjectKey()
     * @param string $objectKey
     */
    public function __construct($objectKey = null)
    {
        $this
            ->setObjectKey($objectKey);
    }
    /**
     * Get ObjectKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getObjectKey()
    {
        return isset($this->ObjectKey) ? $this->ObjectKey : null;
    }
    /**
     * Set ObjectKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $objectKey
     * @return \StructType\ObjectAlreadyExistsException
     */
    public function setObjectKey($objectKey = null)
    {
        // validation for constraint: string
        if (!is_null($objectKey) && !is_string($objectKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($objectKey)), __LINE__);
        }
        if (is_null($objectKey) || (is_array($objectKey) && empty($objectKey))) {
            unset($this->ObjectKey);
        } else {
            $this->ObjectKey = $objectKey;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ObjectAlreadyExistsException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
