<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RemoveUserRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RemoveUserRequest
 * @subpackage Structs
 */
class RemoveUserRequest extends Request
{
    /**
     * The ObjectId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * - pattern: [\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}
     * - type: tns:guid
     * @var string
     */
    public $ObjectId;
    /**
     * The RemoveFromRecycleBin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $RemoveFromRecycleBin;
    /**
     * Constructor method for RemoveUserRequest
     * @uses RemoveUserRequest::setObjectId()
     * @uses RemoveUserRequest::setRemoveFromRecycleBin()
     * @param string $objectId
     * @param bool $removeFromRecycleBin
     */
    public function __construct($objectId = null, $removeFromRecycleBin = null)
    {
        $this
            ->setObjectId($objectId)
            ->setRemoveFromRecycleBin($removeFromRecycleBin);
    }
    /**
     * Get ObjectId value
     * @return string|null
     */
    public function getObjectId()
    {
        return $this->ObjectId;
    }
    /**
     * Set ObjectId value
     * @param string $objectId
     * @return \StructType\RemoveUserRequest
     */
    public function setObjectId($objectId = null)
    {
        // validation for constraint: pattern
        if (is_scalar($objectId) && !preg_match('/[\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}/', $objectId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "[\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}", "%s" given', var_export($objectId, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($objectId) && !is_string($objectId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($objectId)), __LINE__);
        }
        $this->ObjectId = $objectId;
        return $this;
    }
    /**
     * Get RemoveFromRecycleBin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getRemoveFromRecycleBin()
    {
        return isset($this->RemoveFromRecycleBin) ? $this->RemoveFromRecycleBin : null;
    }
    /**
     * Set RemoveFromRecycleBin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $removeFromRecycleBin
     * @return \StructType\RemoveUserRequest
     */
    public function setRemoveFromRecycleBin($removeFromRecycleBin = null)
    {
        if (is_null($removeFromRecycleBin) || (is_array($removeFromRecycleBin) && empty($removeFromRecycleBin))) {
            unset($this->RemoveFromRecycleBin);
        } else {
            $this->RemoveFromRecycleBin = $removeFromRecycleBin;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RemoveUserRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
