<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResetUserPasswordByUpnRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ResetUserPasswordByUpnRequest
 * @subpackage Structs
 */
class ResetUserPasswordByUpnRequest extends Request
{
    /**
     * The ForceChangePassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $ForceChangePassword;
    /**
     * The ForceChangePasswordOnly
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $ForceChangePasswordOnly;
    /**
     * The NewPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NewPassword;
    /**
     * The UserPrincipalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserPrincipalName;
    /**
     * Constructor method for ResetUserPasswordByUpnRequest
     * @uses ResetUserPasswordByUpnRequest::setForceChangePassword()
     * @uses ResetUserPasswordByUpnRequest::setForceChangePasswordOnly()
     * @uses ResetUserPasswordByUpnRequest::setNewPassword()
     * @uses ResetUserPasswordByUpnRequest::setUserPrincipalName()
     * @param bool $forceChangePassword
     * @param bool $forceChangePasswordOnly
     * @param string $newPassword
     * @param string $userPrincipalName
     */
    public function __construct($forceChangePassword = null, $forceChangePasswordOnly = null, $newPassword = null, $userPrincipalName = null)
    {
        $this
            ->setForceChangePassword($forceChangePassword)
            ->setForceChangePasswordOnly($forceChangePasswordOnly)
            ->setNewPassword($newPassword)
            ->setUserPrincipalName($userPrincipalName);
    }
    /**
     * Get ForceChangePassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getForceChangePassword()
    {
        return isset($this->ForceChangePassword) ? $this->ForceChangePassword : null;
    }
    /**
     * Set ForceChangePassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $forceChangePassword
     * @return \StructType\ResetUserPasswordByUpnRequest
     */
    public function setForceChangePassword($forceChangePassword = null)
    {
        if (is_null($forceChangePassword) || (is_array($forceChangePassword) && empty($forceChangePassword))) {
            unset($this->ForceChangePassword);
        } else {
            $this->ForceChangePassword = $forceChangePassword;
        }
        return $this;
    }
    /**
     * Get ForceChangePasswordOnly value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getForceChangePasswordOnly()
    {
        return isset($this->ForceChangePasswordOnly) ? $this->ForceChangePasswordOnly : null;
    }
    /**
     * Set ForceChangePasswordOnly value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $forceChangePasswordOnly
     * @return \StructType\ResetUserPasswordByUpnRequest
     */
    public function setForceChangePasswordOnly($forceChangePasswordOnly = null)
    {
        if (is_null($forceChangePasswordOnly) || (is_array($forceChangePasswordOnly) && empty($forceChangePasswordOnly))) {
            unset($this->ForceChangePasswordOnly);
        } else {
            $this->ForceChangePasswordOnly = $forceChangePasswordOnly;
        }
        return $this;
    }
    /**
     * Get NewPassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewPassword()
    {
        return isset($this->NewPassword) ? $this->NewPassword : null;
    }
    /**
     * Set NewPassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newPassword
     * @return \StructType\ResetUserPasswordByUpnRequest
     */
    public function setNewPassword($newPassword = null)
    {
        // validation for constraint: string
        if (!is_null($newPassword) && !is_string($newPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newPassword)), __LINE__);
        }
        if (is_null($newPassword) || (is_array($newPassword) && empty($newPassword))) {
            unset($this->NewPassword);
        } else {
            $this->NewPassword = $newPassword;
        }
        return $this;
    }
    /**
     * Get UserPrincipalName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserPrincipalName()
    {
        return isset($this->UserPrincipalName) ? $this->UserPrincipalName : null;
    }
    /**
     * Set UserPrincipalName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userPrincipalName
     * @return \StructType\ResetUserPasswordByUpnRequest
     */
    public function setUserPrincipalName($userPrincipalName = null)
    {
        // validation for constraint: string
        if (!is_null($userPrincipalName) && !is_string($userPrincipalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userPrincipalName)), __LINE__);
        }
        if (is_null($userPrincipalName) || (is_array($userPrincipalName) && empty($userPrincipalName))) {
            unset($this->UserPrincipalName);
        } else {
            $this->UserPrincipalName = $userPrincipalName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResetUserPasswordByUpnRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
