<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RestoreUserByUpnRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RestoreUserByUpnRequest
 * @subpackage Structs
 */
class RestoreUserByUpnRequest extends Request
{
    /**
     * The AutoReconcileProxyConflicts
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $AutoReconcileProxyConflicts;
    /**
     * The NewUserPrincipalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NewUserPrincipalName;
    /**
     * The UserPrincipalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserPrincipalName;
    /**
     * Constructor method for RestoreUserByUpnRequest
     * @uses RestoreUserByUpnRequest::setAutoReconcileProxyConflicts()
     * @uses RestoreUserByUpnRequest::setNewUserPrincipalName()
     * @uses RestoreUserByUpnRequest::setUserPrincipalName()
     * @param bool $autoReconcileProxyConflicts
     * @param string $newUserPrincipalName
     * @param string $userPrincipalName
     */
    public function __construct($autoReconcileProxyConflicts = null, $newUserPrincipalName = null, $userPrincipalName = null)
    {
        $this
            ->setAutoReconcileProxyConflicts($autoReconcileProxyConflicts)
            ->setNewUserPrincipalName($newUserPrincipalName)
            ->setUserPrincipalName($userPrincipalName);
    }
    /**
     * Get AutoReconcileProxyConflicts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getAutoReconcileProxyConflicts()
    {
        return isset($this->AutoReconcileProxyConflicts) ? $this->AutoReconcileProxyConflicts : null;
    }
    /**
     * Set AutoReconcileProxyConflicts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $autoReconcileProxyConflicts
     * @return \StructType\RestoreUserByUpnRequest
     */
    public function setAutoReconcileProxyConflicts($autoReconcileProxyConflicts = null)
    {
        if (is_null($autoReconcileProxyConflicts) || (is_array($autoReconcileProxyConflicts) && empty($autoReconcileProxyConflicts))) {
            unset($this->AutoReconcileProxyConflicts);
        } else {
            $this->AutoReconcileProxyConflicts = $autoReconcileProxyConflicts;
        }
        return $this;
    }
    /**
     * Get NewUserPrincipalName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewUserPrincipalName()
    {
        return isset($this->NewUserPrincipalName) ? $this->NewUserPrincipalName : null;
    }
    /**
     * Set NewUserPrincipalName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newUserPrincipalName
     * @return \StructType\RestoreUserByUpnRequest
     */
    public function setNewUserPrincipalName($newUserPrincipalName = null)
    {
        // validation for constraint: string
        if (!is_null($newUserPrincipalName) && !is_string($newUserPrincipalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newUserPrincipalName)), __LINE__);
        }
        if (is_null($newUserPrincipalName) || (is_array($newUserPrincipalName) && empty($newUserPrincipalName))) {
            unset($this->NewUserPrincipalName);
        } else {
            $this->NewUserPrincipalName = $newUserPrincipalName;
        }
        return $this;
    }
    /**
     * Get UserPrincipalName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserPrincipalName()
    {
        return isset($this->UserPrincipalName) ? $this->UserPrincipalName : null;
    }
    /**
     * Set UserPrincipalName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userPrincipalName
     * @return \StructType\RestoreUserByUpnRequest
     */
    public function setUserPrincipalName($userPrincipalName = null)
    {
        // validation for constraint: string
        if (!is_null($userPrincipalName) && !is_string($userPrincipalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userPrincipalName)), __LINE__);
        }
        if (is_null($userPrincipalName) || (is_array($userPrincipalName) && empty($userPrincipalName))) {
            unset($this->UserPrincipalName);
        } else {
            $this->UserPrincipalName = $userPrincipalName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RestoreUserByUpnRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
