<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RestoreUserLicenseErrorException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RestoreUserLicenseErrorException
 * @subpackage Structs
 */
class RestoreUserLicenseErrorException extends DataOperationException
{
    /**
     * The Licenses
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAccountSkuIdentifier
     */
    public $Licenses;
    /**
     * Constructor method for RestoreUserLicenseErrorException
     * @uses RestoreUserLicenseErrorException::setLicenses()
     * @param \ArrayType\ArrayOfAccountSkuIdentifier $licenses
     */
    public function __construct(\ArrayType\ArrayOfAccountSkuIdentifier $licenses = null)
    {
        $this
            ->setLicenses($licenses);
    }
    /**
     * Get Licenses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAccountSkuIdentifier|null
     */
    public function getLicenses()
    {
        return isset($this->Licenses) ? $this->Licenses : null;
    }
    /**
     * Set Licenses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAccountSkuIdentifier $licenses
     * @return \StructType\RestoreUserLicenseErrorException
     */
    public function setLicenses(\ArrayType\ArrayOfAccountSkuIdentifier $licenses = null)
    {
        if (is_null($licenses) || (is_array($licenses) && empty($licenses))) {
            unset($this->Licenses);
        } else {
            $this->Licenses = $licenses;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RestoreUserLicenseErrorException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
