<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServicePrincipalExtended StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ServicePrincipalExtended
 * @subpackage Structs
 */
class ServicePrincipalExtended extends ServicePrincipal
{
    /**
     * The Credentials
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfServicePrincipalCredential
     */
    public $Credentials;
    /**
     * Constructor method for ServicePrincipalExtended
     * @uses ServicePrincipalExtended::setCredentials()
     * @param \ArrayType\ArrayOfServicePrincipalCredential $credentials
     */
    public function __construct(\ArrayType\ArrayOfServicePrincipalCredential $credentials = null)
    {
        $this
            ->setCredentials($credentials);
    }
    /**
     * Get Credentials value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfServicePrincipalCredential|null
     */
    public function getCredentials()
    {
        return isset($this->Credentials) ? $this->Credentials : null;
    }
    /**
     * Set Credentials value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfServicePrincipalCredential $credentials
     * @return \StructType\ServicePrincipalExtended
     */
    public function setCredentials(\ArrayType\ArrayOfServicePrincipalCredential $credentials = null)
    {
        if (is_null($credentials) || (is_array($credentials) && empty($credentials))) {
            unset($this->Credentials);
        } else {
            $this->Credentials = $credentials;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePrincipalExtended
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
