<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetAdministrativeUnitRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetAdministrativeUnitRequest
 * @subpackage Structs
 */
class SetAdministrativeUnitRequest extends Request
{
    /**
     * The AdministrativeUnit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdministrativeUnit
     */
    public $AdministrativeUnit;
    /**
     * Constructor method for SetAdministrativeUnitRequest
     * @uses SetAdministrativeUnitRequest::setAdministrativeUnit()
     * @param \StructType\AdministrativeUnit $administrativeUnit
     */
    public function __construct(\StructType\AdministrativeUnit $administrativeUnit = null)
    {
        $this
            ->setAdministrativeUnit($administrativeUnit);
    }
    /**
     * Get AdministrativeUnit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdministrativeUnit|null
     */
    public function getAdministrativeUnit()
    {
        return isset($this->AdministrativeUnit) ? $this->AdministrativeUnit : null;
    }
    /**
     * Set AdministrativeUnit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AdministrativeUnit $administrativeUnit
     * @return \StructType\SetAdministrativeUnitRequest
     */
    public function setAdministrativeUnit(\StructType\AdministrativeUnit $administrativeUnit = null)
    {
        if (is_null($administrativeUnit) || (is_array($administrativeUnit) && empty($administrativeUnit))) {
            unset($this->AdministrativeUnit);
        } else {
            $this->AdministrativeUnit = $administrativeUnit;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetAdministrativeUnitRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
