<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetCompanyAllowedDataLocationRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetCompanyAllowedDataLocationRequest
 * @subpackage Structs
 */
class SetCompanyAllowedDataLocationRequest extends Request
{
    /**
     * The InitialDomain
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InitialDomain;
    /**
     * The IsDefault
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsDefault;
    /**
     * The Location
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Location;
    /**
     * The Overwrite
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Overwrite;
    /**
     * The ServiceType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ServiceType;
    /**
     * Constructor method for SetCompanyAllowedDataLocationRequest
     * @uses SetCompanyAllowedDataLocationRequest::setInitialDomain()
     * @uses SetCompanyAllowedDataLocationRequest::setIsDefault()
     * @uses SetCompanyAllowedDataLocationRequest::setLocation()
     * @uses SetCompanyAllowedDataLocationRequest::setOverwrite()
     * @uses SetCompanyAllowedDataLocationRequest::setServiceType()
     * @param string $initialDomain
     * @param bool $isDefault
     * @param string $location
     * @param bool $overwrite
     * @param string $serviceType
     */
    public function __construct($initialDomain = null, $isDefault = null, $location = null, $overwrite = null, $serviceType = null)
    {
        $this
            ->setInitialDomain($initialDomain)
            ->setIsDefault($isDefault)
            ->setLocation($location)
            ->setOverwrite($overwrite)
            ->setServiceType($serviceType);
    }
    /**
     * Get InitialDomain value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInitialDomain()
    {
        return isset($this->InitialDomain) ? $this->InitialDomain : null;
    }
    /**
     * Set InitialDomain value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $initialDomain
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public function setInitialDomain($initialDomain = null)
    {
        // validation for constraint: string
        if (!is_null($initialDomain) && !is_string($initialDomain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($initialDomain)), __LINE__);
        }
        if (is_null($initialDomain) || (is_array($initialDomain) && empty($initialDomain))) {
            unset($this->InitialDomain);
        } else {
            $this->InitialDomain = $initialDomain;
        }
        return $this;
    }
    /**
     * Get IsDefault value
     * @return bool|null
     */
    public function getIsDefault()
    {
        return $this->IsDefault;
    }
    /**
     * Set IsDefault value
     * @param bool $isDefault
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public function setIsDefault($isDefault = null)
    {
        $this->IsDefault = $isDefault;
        return $this;
    }
    /**
     * Get Location value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLocation()
    {
        return isset($this->Location) ? $this->Location : null;
    }
    /**
     * Set Location value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $location
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public function setLocation($location = null)
    {
        // validation for constraint: string
        if (!is_null($location) && !is_string($location)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($location)), __LINE__);
        }
        if (is_null($location) || (is_array($location) && empty($location))) {
            unset($this->Location);
        } else {
            $this->Location = $location;
        }
        return $this;
    }
    /**
     * Get Overwrite value
     * @return bool|null
     */
    public function getOverwrite()
    {
        return $this->Overwrite;
    }
    /**
     * Set Overwrite value
     * @param bool $overwrite
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public function setOverwrite($overwrite = null)
    {
        $this->Overwrite = $overwrite;
        return $this;
    }
    /**
     * Get ServiceType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServiceType()
    {
        return isset($this->ServiceType) ? $this->ServiceType : null;
    }
    /**
     * Set ServiceType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serviceType
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public function setServiceType($serviceType = null)
    {
        // validation for constraint: string
        if (!is_null($serviceType) && !is_string($serviceType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceType)), __LINE__);
        }
        if (is_null($serviceType) || (is_array($serviceType) && empty($serviceType))) {
            unset($this->ServiceType);
        } else {
            $this->ServiceType = $serviceType;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetCompanyAllowedDataLocationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
