<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetCompanyContactInformationRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetCompanyContactInformationRequest
 * @subpackage Structs
 */
class SetCompanyContactInformationRequest extends Request
{
    /**
     * The MarketingNotificationEmails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $MarketingNotificationEmails;
    /**
     * The TechnicalNotificationEmails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $TechnicalNotificationEmails;
    /**
     * Constructor method for SetCompanyContactInformationRequest
     * @uses SetCompanyContactInformationRequest::setMarketingNotificationEmails()
     * @uses SetCompanyContactInformationRequest::setTechnicalNotificationEmails()
     * @param \ArrayType\ArrayOfstring $marketingNotificationEmails
     * @param \ArrayType\ArrayOfstring $technicalNotificationEmails
     */
    public function __construct(\ArrayType\ArrayOfstring $marketingNotificationEmails = null, \ArrayType\ArrayOfstring $technicalNotificationEmails = null)
    {
        $this
            ->setMarketingNotificationEmails($marketingNotificationEmails)
            ->setTechnicalNotificationEmails($technicalNotificationEmails);
    }
    /**
     * Get MarketingNotificationEmails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getMarketingNotificationEmails()
    {
        return isset($this->MarketingNotificationEmails) ? $this->MarketingNotificationEmails : null;
    }
    /**
     * Set MarketingNotificationEmails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $marketingNotificationEmails
     * @return \StructType\SetCompanyContactInformationRequest
     */
    public function setMarketingNotificationEmails(\ArrayType\ArrayOfstring $marketingNotificationEmails = null)
    {
        if (is_null($marketingNotificationEmails) || (is_array($marketingNotificationEmails) && empty($marketingNotificationEmails))) {
            unset($this->MarketingNotificationEmails);
        } else {
            $this->MarketingNotificationEmails = $marketingNotificationEmails;
        }
        return $this;
    }
    /**
     * Get TechnicalNotificationEmails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getTechnicalNotificationEmails()
    {
        return isset($this->TechnicalNotificationEmails) ? $this->TechnicalNotificationEmails : null;
    }
    /**
     * Set TechnicalNotificationEmails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $technicalNotificationEmails
     * @return \StructType\SetCompanyContactInformationRequest
     */
    public function setTechnicalNotificationEmails(\ArrayType\ArrayOfstring $technicalNotificationEmails = null)
    {
        if (is_null($technicalNotificationEmails) || (is_array($technicalNotificationEmails) && empty($technicalNotificationEmails))) {
            unset($this->TechnicalNotificationEmails);
        } else {
            $this->TechnicalNotificationEmails = $technicalNotificationEmails;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetCompanyContactInformationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
