<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetCompanySecurityComplianceContactInformationRequest
 * StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetCompanySecurityComplianceContactInformationRequest
 * @subpackage Structs
 */
class SetCompanySecurityComplianceContactInformationRequest extends Request
{
    /**
     * The SecurityComplianceNotificationEmails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $SecurityComplianceNotificationEmails;
    /**
     * The SecurityComplianceNotificationPhones
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $SecurityComplianceNotificationPhones;
    /**
     * Constructor method for SetCompanySecurityComplianceContactInformationRequest
     * @uses SetCompanySecurityComplianceContactInformationRequest::setSecurityComplianceNotificationEmails()
     * @uses SetCompanySecurityComplianceContactInformationRequest::setSecurityComplianceNotificationPhones()
     * @param \ArrayType\ArrayOfstring $securityComplianceNotificationEmails
     * @param \ArrayType\ArrayOfstring $securityComplianceNotificationPhones
     */
    public function __construct(\ArrayType\ArrayOfstring $securityComplianceNotificationEmails = null, \ArrayType\ArrayOfstring $securityComplianceNotificationPhones = null)
    {
        $this
            ->setSecurityComplianceNotificationEmails($securityComplianceNotificationEmails)
            ->setSecurityComplianceNotificationPhones($securityComplianceNotificationPhones);
    }
    /**
     * Get SecurityComplianceNotificationEmails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getSecurityComplianceNotificationEmails()
    {
        return isset($this->SecurityComplianceNotificationEmails) ? $this->SecurityComplianceNotificationEmails : null;
    }
    /**
     * Set SecurityComplianceNotificationEmails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $securityComplianceNotificationEmails
     * @return \StructType\SetCompanySecurityComplianceContactInformationRequest
     */
    public function setSecurityComplianceNotificationEmails(\ArrayType\ArrayOfstring $securityComplianceNotificationEmails = null)
    {
        if (is_null($securityComplianceNotificationEmails) || (is_array($securityComplianceNotificationEmails) && empty($securityComplianceNotificationEmails))) {
            unset($this->SecurityComplianceNotificationEmails);
        } else {
            $this->SecurityComplianceNotificationEmails = $securityComplianceNotificationEmails;
        }
        return $this;
    }
    /**
     * Get SecurityComplianceNotificationPhones value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getSecurityComplianceNotificationPhones()
    {
        return isset($this->SecurityComplianceNotificationPhones) ? $this->SecurityComplianceNotificationPhones : null;
    }
    /**
     * Set SecurityComplianceNotificationPhones value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $securityComplianceNotificationPhones
     * @return \StructType\SetCompanySecurityComplianceContactInformationRequest
     */
    public function setSecurityComplianceNotificationPhones(\ArrayType\ArrayOfstring $securityComplianceNotificationPhones = null)
    {
        if (is_null($securityComplianceNotificationPhones) || (is_array($securityComplianceNotificationPhones) && empty($securityComplianceNotificationPhones))) {
            unset($this->SecurityComplianceNotificationPhones);
        } else {
            $this->SecurityComplianceNotificationPhones = $securityComplianceNotificationPhones;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetCompanySecurityComplianceContactInformationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
