<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetGroupRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetGroupRequest
 * @subpackage Structs
 */
class SetGroupRequest extends Request
{
    /**
     * The Group
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Group
     */
    public $Group;
    /**
     * Constructor method for SetGroupRequest
     * @uses SetGroupRequest::setGroup()
     * @param \StructType\Group $group
     */
    public function __construct(\StructType\Group $group = null)
    {
        $this
            ->setGroup($group);
    }
    /**
     * Get Group value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Group|null
     */
    public function getGroup()
    {
        return isset($this->Group) ? $this->Group : null;
    }
    /**
     * Set Group value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Group $group
     * @return \StructType\SetGroupRequest
     */
    public function setGroup(\StructType\Group $group = null)
    {
        if (is_null($group) || (is_array($group) && empty($group))) {
            unset($this->Group);
        } else {
            $this->Group = $group;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetGroupRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
