<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetPartnerInformationRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetPartnerInformationRequest
 * @subpackage Structs
 */
class SetPartnerInformationRequest extends Request
{
    /**
     * The PartnerInformation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PartnerInformation
     */
    public $PartnerInformation;
    /**
     * Constructor method for SetPartnerInformationRequest
     * @uses SetPartnerInformationRequest::setPartnerInformation()
     * @param \StructType\PartnerInformation $partnerInformation
     */
    public function __construct(\StructType\PartnerInformation $partnerInformation = null)
    {
        $this
            ->setPartnerInformation($partnerInformation);
    }
    /**
     * Get PartnerInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PartnerInformation|null
     */
    public function getPartnerInformation()
    {
        return isset($this->PartnerInformation) ? $this->PartnerInformation : null;
    }
    /**
     * Set PartnerInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PartnerInformation $partnerInformation
     * @return \StructType\SetPartnerInformationRequest
     */
    public function setPartnerInformation(\StructType\PartnerInformation $partnerInformation = null)
    {
        if (is_null($partnerInformation) || (is_array($partnerInformation) && empty($partnerInformation))) {
            unset($this->PartnerInformation);
        } else {
            $this->PartnerInformation = $partnerInformation;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetPartnerInformationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
