<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetServicePrincipalRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SetServicePrincipalRequest
 * @subpackage Structs
 */
class SetServicePrincipalRequest extends Request
{
    /**
     * The ServicePrincipal
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServicePrincipal
     */
    public $ServicePrincipal;
    /**
     * Constructor method for SetServicePrincipalRequest
     * @uses SetServicePrincipalRequest::setServicePrincipal()
     * @param \StructType\ServicePrincipal $servicePrincipal
     */
    public function __construct(\StructType\ServicePrincipal $servicePrincipal = null)
    {
        $this
            ->setServicePrincipal($servicePrincipal);
    }
    /**
     * Get ServicePrincipal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServicePrincipal|null
     */
    public function getServicePrincipal()
    {
        return isset($this->ServicePrincipal) ? $this->ServicePrincipal : null;
    }
    /**
     * Set ServicePrincipal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ServicePrincipal $servicePrincipal
     * @return \StructType\SetServicePrincipalRequest
     */
    public function setServicePrincipal(\StructType\ServicePrincipal $servicePrincipal = null)
    {
        if (is_null($servicePrincipal) || (is_array($servicePrincipal) && empty($servicePrincipal))) {
            unset($this->ServicePrincipal);
        } else {
            $this->ServicePrincipal = $servicePrincipal;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetServicePrincipalRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
