<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StringSyntaxValidationException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:StringSyntaxValidationException
 * @subpackage Structs
 */
class StringSyntaxValidationException extends PropertyValidationException
{
    /**
     * The RegularExpression
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RegularExpression;
    /**
     * Constructor method for StringSyntaxValidationException
     * @uses StringSyntaxValidationException::setRegularExpression()
     * @param string $regularExpression
     */
    public function __construct($regularExpression = null)
    {
        $this
            ->setRegularExpression($regularExpression);
    }
    /**
     * Get RegularExpression value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegularExpression()
    {
        return isset($this->RegularExpression) ? $this->RegularExpression : null;
    }
    /**
     * Set RegularExpression value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $regularExpression
     * @return \StructType\StringSyntaxValidationException
     */
    public function setRegularExpression($regularExpression = null)
    {
        // validation for constraint: string
        if (!is_null($regularExpression) && !is_string($regularExpression)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regularExpression)), __LINE__);
        }
        if (is_null($regularExpression) || (is_array($regularExpression) && empty($regularExpression))) {
            unset($this->RegularExpression);
        } else {
            $this->RegularExpression = $regularExpression;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StringSyntaxValidationException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
