<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThrottlingException StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ThrottlingException
 * @subpackage Structs
 */
class ThrottlingException extends MsolAdministrationException
{
    /**
     * The RetryWaitPeriod
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RetryWaitPeriod;
    /**
     * Constructor method for ThrottlingException
     * @uses ThrottlingException::setRetryWaitPeriod()
     * @param int $retryWaitPeriod
     */
    public function __construct($retryWaitPeriod = null)
    {
        $this
            ->setRetryWaitPeriod($retryWaitPeriod);
    }
    /**
     * Get RetryWaitPeriod value
     * @return int|null
     */
    public function getRetryWaitPeriod()
    {
        return $this->RetryWaitPeriod;
    }
    /**
     * Set RetryWaitPeriod value
     * @param int $retryWaitPeriod
     * @return \StructType\ThrottlingException
     */
    public function setRetryWaitPeriod($retryWaitPeriod = null)
    {
        // validation for constraint: int
        if (!is_null($retryWaitPeriod) && !is_numeric($retryWaitPeriod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($retryWaitPeriod)), __LINE__);
        }
        $this->RetryWaitPeriod = $retryWaitPeriod;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ThrottlingException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
