<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserIdentityHeader StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:UserIdentityHeader
 * @subpackage Structs
 */
class UserIdentityHeader extends AbstractStructBase
{
    /**
     * The BearerToken
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BearerToken;
    /**
     * The LiveToken
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LiveToken;
    /**
     * Constructor method for UserIdentityHeader
     * @uses UserIdentityHeader::setBearerToken()
     * @uses UserIdentityHeader::setLiveToken()
     * @param string $bearerToken
     * @param string $liveToken
     */
    public function __construct($bearerToken = null, $liveToken = null)
    {
        $this
            ->setBearerToken($bearerToken)
            ->setLiveToken($liveToken);
    }
    /**
     * Get BearerToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBearerToken()
    {
        return isset($this->BearerToken) ? $this->BearerToken : null;
    }
    /**
     * Set BearerToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bearerToken
     * @return \StructType\UserIdentityHeader
     */
    public function setBearerToken($bearerToken = null)
    {
        // validation for constraint: string
        if (!is_null($bearerToken) && !is_string($bearerToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bearerToken)), __LINE__);
        }
        if (is_null($bearerToken) || (is_array($bearerToken) && empty($bearerToken))) {
            unset($this->BearerToken);
        } else {
            $this->BearerToken = $bearerToken;
        }
        return $this;
    }
    /**
     * Get LiveToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLiveToken()
    {
        return isset($this->LiveToken) ? $this->LiveToken : null;
    }
    /**
     * Set LiveToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $liveToken
     * @return \StructType\UserIdentityHeader
     */
    public function setLiveToken($liveToken = null)
    {
        // validation for constraint: string
        if (!is_null($liveToken) && !is_string($liveToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($liveToken)), __LINE__);
        }
        if (is_null($liveToken) || (is_array($liveToken) && empty($liveToken))) {
            unset($this->LiveToken);
        } else {
            $this->LiveToken = $liveToken;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UserIdentityHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
